SystemOrganization addCategory: #'GOODS-Cache'!
SystemOrganization addCategory: #'GOODS-Cache Policies'!
SystemOrganization addCategory: #'GOODS-Database'!
SystemOrganization addCategory: #'GOODS-Documentation'!
SystemOrganization addCategory: #'GOODS-Isolation Level'!
SystemOrganization addCategory: #'GOODS-Lock Policies'!
SystemOrganization addCategory: #'GOODS-Logging'!
SystemOrganization addCategory: #'GOODS-Metadata'!
SystemOrganization addCategory: #'GOODS-Protocol'!
SystemOrganization addCategory: #'GOODS-Test'!
SystemOrganization addCategory: #'GOODS-WriteBarrier'!

!Boolean class methodsFor: '*goods' stamp: 'AB 3/10/2002 17:04'!
goodsDescriptor
	self error: 'Cannot store immediate values as references'	! !

!Boolean methodsFor: '*goods' stamp: 'avi 2/27/2004 23:18'!
goodsIsImmediateValue
	^ true! !

!Boolean methodsFor: '*goods' stamp: 'cds 6/25/2008 10:01'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 2; next: 3 put: 0; nextPut: (self ifTrue: [1] ifFalse: [0])! !

ProtoObject subclass: #KKObjectProxy
	instanceVariableNames: 'key value database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Database'!

!KKObjectProxy class methodsFor: 'as yet unclassified' stamp: 'cds 6/3/2006 14:05'!
database: aDatabase key: key
	^ self basicNew
		xxxDatabase: aDatabase;
		xxxKey: key! !

!KKObjectProxy methodsFor: 'system primitives' stamp: 'cds 9/16/2006 18:51'!
doesNotUnderstand: aMessage
	^ self xxxObject perform: aMessage selector withArguments: aMessage arguments! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'cds 6/3/2006 14:05'!
goodsIsImmediateValue
	^ false! !

!KKObjectProxy methodsFor: 'testing' stamp: 'cds 6/3/2006 14:06'!
isInMemory
	^ value notNil! !

!KKObjectProxy methodsFor: 'testing' stamp: 'cds 6/3/2006 14:05'!
isMorph
	"satisfy CommandHistory"
	^ false! !

!KKObjectProxy methodsFor: 'accessing' stamp: 'cds 9/16/2006 18:29'!
xxxDatabase
	^database! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'cds 6/3/2006 14:05'!
xxxDatabase: aDatabase
	database := aDatabase! !

!KKObjectProxy methodsFor: 'testing' stamp: 'cds 4/3/2010 10:24'!
xxxIsProxy

	^true! !

!KKObjectProxy methodsFor: 'accessing' stamp: 'cds 6/3/2006 14:06'!
xxxKey
	^ key! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'cds 6/3/2006 14:06'!
xxxKey: oid
	key := oid! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 21:40'!
xxxObject
	value ifNil: [^value := database at: key "forProxy: self...not quite ready for become: yet"].
	^ value! !

!UUID methodsFor: '*goods' stamp: 'cds 7/6/2006 15:12'!
goodsIsImmutable
	^ true! !

!Class class methodsFor: '*goods' stamp: 'rbb 8/6/2004 11:56'!
goodsDescriptorClass
	^ KKMetaclassDescriptor
! !

!String class methodsFor: '*goods' stamp: 'AB 3/8/2002 15:29'!
goodsDescriptorClass 
	^ KKStringDescriptor! !

!String methodsFor: '*goods' stamp: 'avi 2/26/2004 16:56'!
goodsIsImmutable
	^ true! !

Error subclass: #KKCommitFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Database'!

Error subclass: #KKLockFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Lock Policies'!

!KKLockFailed commentStamp: 'cds 7/10/2008 14:15' prior: 0!
I am signaled when a lock cannot be acquired on an object and such a lock is required by the current lock policy.!

!Set class methodsFor: '*goods' stamp: 'avi 10/25/2003 03:19'!
tallyDescriptor
	^ KKSingleFieldContainer intField! !

TestCase subclass: #KKAbstractDBTest
	instanceVariableNames: 'dbOne dbTwo connOne connTwo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKAbstractDBTest methodsFor: 'settings' stamp: 'cds 4/21/2011 17:30'!
dbHost
	^ 'localhost'! !

!KKAbstractDBTest methodsFor: 'settings' stamp: 'cds 4/21/2011 17:30'!
dbPort
	^ 2006! !

!KKAbstractDBTest methodsFor: 'running' stamp: 'cds 4/21/2011 17:30'!
newConnection
	^ KKConnection 
		hostname: self dbHost
		port: self dbPort! !

!KKAbstractDBTest methodsFor: 'running' stamp: 'cds 4/21/2011 17:29'!
setUp
	super setUp.
	connOne := self newConnection.
	connTwo := self newConnection.
	dbOne := KKDatabase connection: connOne.
	dbOne root: Dictionary new; commit.
	dbTwo := KKDatabase connection: connTwo.! !

!KKAbstractDBTest methodsFor: 'running' stamp: 'cds 4/21/2011 17:29'!
tearDown
	super tearDown.
	[dbOne logout] on: Error do: [:ex | ].
	[dbTwo logout] on: Error do: [:ex | ].
	connOne := nil.
	connTwo := nil.
	dbOne := nil.
	dbTwo := nil.! !

KKAbstractDBTest subclass: #KKDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKDBTest methodsFor: 'tests' stamp: 'CDavidShaffer 12/30/2012 09:33'!
ftestObjectWithNoIVars

	dbOne root at: 'o1' put: KKObjectWithNoIVarsForTest new.
	dbOne root at: 'o2' put: KKObjectWithNoIVarsForTest new.
	dbOne commit.
	
	self halt: 'do a gc in GOODS then proceed'.
	dbTwo refresh.
	self assert: ((dbTwo root at: 'o2') isKindOf: KKObjectWithNoIVarsForTest)! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/15/2008 13:30'!
prepareConflictFreeLocking
	dbOne root: KKHolderForWBTest new.
	dbOne commit.
	dbOne := KKDatabase connection: self newConnection.
	dbOne installWriteBarrier: KKManualWriteBarrier new.
	dbTwo installWriteBarrier: KKManualWriteBarrier new.
	dbOne useConflictFreeLocking timeoutMilliseconds: 0.
	dbTwo useConflictFreeLocking timeoutMilliseconds: 0! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/15/2008 13:25'!
preparePessimisticLocking
	dbOne root: KKHolderForWBTest new.
	dbOne commit.
	dbOne := KKDatabase connection: self newConnection.
	dbOne installWriteBarrier: KKManualWriteBarrier new.
	dbTwo installWriteBarrier: KKManualWriteBarrier new.
	dbOne usePessimisticLocking timeoutMilliseconds: 0.
	dbTwo usePessimisticLocking timeoutMilliseconds: 0! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 6/25/2008 10:02'!
testBoolean
	dbOne root at: 'true' put: true.
	dbOne root at: 'false' put: false.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'true').
	self deny: (dbTwo root at: 'false').! !

!KKDBTest methodsFor: 'cache policy tests' stamp: 'cds 4/21/2011 20:40'!
testCacheRelease
	"This is a subtle integration test.  We populate the database with manual write barrier supporting objects.  Then we create a new session, install an LRR cache policy in that session and set its cache size very small.  As objects are loaded, older ones should be expired from the cache.  We check this by monitoring the cache size (pinned + volatile)."! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 4/3/2010 14:39'!
testCharacters
	dbOne root at: 'c' put: $c.
	dbOne root at: 'd' put: $d.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'c') = $c.
	self assert: (dbTwo root at: 'd') = $d.
	self assert: (String streamContents: [:s | s nextPut: (dbTwo root at: 'c'); nextPut: (dbTwo root at: 'd')]) = 'cd'.! !

!KKDBTest methodsFor: 'tests' stamp: 'avi 8/6/2004 11:49'!
testClasses
	dbOne root at: 'dict' put: Dictionary.
	dbOne root at: 'oc' put: OrderedCollection.
	dbOne commit.
	self assert: (dbTwo root at: 'dict') = Dictionary.
	self assert: (dbTwo root at: 'oc') = OrderedCollection
! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 5/24/2010 00:50'!
testCommitWithRetry
	| count result |
	dbOne root at: 'x' put: 23.
	dbOne root at: 'y' put: 42.
	dbOne commit.
	dbTwo refresh. 
	dbTwo root at: 'x'.
	count := 0.
	result := dbTwo commitWithRetry: 
		[count := count + 1.
	
		"Cause a conflict the first time around."
		count = 1 ifTrue:
			[dbOne root at: 'r' put: 25.
			dbOne commit].
		
		"Do this both times.  The second time these are the only changes."	
		dbTwo root at: 's' put: 26.
		dbTwo root at: 'y' put: 43.
		count].
	dbOne refresh.
	self assert: (dbOne root at: 's') = 26.
	self assert: (dbOne root at: 'y') = 43.
	self assert: count = 2.
	self assert: result = 2! !

!KKDBTest methodsFor: 'tests' stamp: 'avi 10/24/2004 02:00'!
testConflict
	| |
	dbOne root at: 'x' put: 23.
	dbOne root at: 'y' put: 42.
	dbOne commit.
	dbTwo refresh. 
	dbTwo root at: 'x'.
	
	dbOne root at: 'x' put: 25.
	dbOne commit.
	dbTwo root at: 'x' put: 26.
	self should: [dbTwo commit] raise: KKCommitFailure! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/17/2008 11:17'!
testConflictFreeLocking
	"Conflict-free locking should lock-on-read or write"

	self prepareConflictFreeLocking.

	"Exclusive locks the root object"
	dbOne root value1: KKObjectForWBTest new.
	
	"Other session shouldn't be able to /read/"
	self 
		should: [ dbTwo root ]
		raise: KKLockFailed! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 4/3/2010 12:30'!
testConflictFreeLockingCommitDowngrades
	"Conflict-free locking should downgrade exclusive locks to shared locks on commit"
	self prepareConflictFreeLocking.

	dbOne root value1: KKObjectForWBTest new.	"locks"
	dbOne commit.	"downgrades"
		
	"We should be able to read..."
	self assert: (dbTwo root value1 yourself isKindOf: KKObjectForWBTest).
	
	"...but not write"
	self should: [dbTwo root value1: KKObjectForWBTest new] raise: KKLockFailed.! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/17/2008 11:16'!
testConflictFreeLockingNoConflict
	"Conflict-free locking should lock-on-write"
	self prepareConflictFreeLocking.

	dbOne root value1: KKObjectForWBTest new.	"locks"
	dbOne root value2: KKObjectForWBTest new.	"locks"
	dbOne commit.	"unlocks"


	"The following two statements lock different objects"	
	dbOne root value1 name: 'blah'.

	dbTwo root value2 name: 'foo'.

	dbOne commit.
	dbTwo commit.! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/17/2008 13:15'!
testConflictFreeLockingRollback
	"Conflict-free locking should downgrade write locks to shared locks on rollback"

	self prepareConflictFreeLocking.

	"Locks the root object"
	dbOne root value1: KKObjectForWBTest new.
	dbOne rollback. "downgrades to shared lock"
	
	self waitAsyncUnlock.
	
	"We should be able to read it now"
	dbTwo root.
	"...but not write it since dbOne has it loaded"
	self should: [dbTwo root value1: KKObjectForWBTest new] raise: KKLockFailed! !

!KKDBTest methodsFor: 'tests' stamp: 'avi 11/7/2003 23:34'!
testConnection
	self assert: connOne isConnected.
	self assert: connTwo isConnected! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 4/27/2011 13:22'!
testFlushAllRemovesAllUnreferenced

	self assert: dbTwo allCachesObjectCount  = 0.

	"Notice that we copy all of these string literals otherwise, since the compiled method contains references to them, they will not be released from weak dictionary during flush."
	dbTwo root at: 'foo' copy put: 'bar' copy.
	dbTwo root at: 'x' copy put: 'y' copy.
	dbTwo commit.

	self assert: dbTwo allCachesObjectCount > 0.
	
	dbTwo flushAll.
	
	self assert: dbTwo allCachesObjectCount = 0.	! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 4/27/2011 13:23'!
testFlushRemovesSomething

	| preFlushCount |
	self assert: dbTwo allCachesObjectCount  = 0.

	"Notice that we copy all of these string literals otherwise, since the compiled method contains references to them, they will not be released from weak dictionary during flush."
	dbTwo root at: 'foo' copy put: 'bar' copy.
	dbTwo root at: 'x' copy put: 'y' copy.
	dbTwo commit.

	self assert: dbTwo allCachesObjectCount > 0.
	
	preFlushCount := dbTwo allCachesObjectCount.
	
	dbTwo flushAll.
	
	self assert: dbTwo allCachesObjectCount < preFlushCount! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 10/18/2010 19:29'!
testGoodsUpdateNotSentOnRollbackOfImmutable
	"If we rollback a session, unmodified objects should not be sent #goodsUpdate even if there is NO write barrier."
	| counter |
	dbOne := KKDatabase connection: connOne.
	dbOne root 
		at: 'counter'
		put: KKImmutableGoodsUpdateCounter new.
	dbOne commit.
	counter := dbTwo root at: 'counter'.
	self assert: counter goodsUpdateCount = 0.
	dbTwo rollback.
	self assert: counter goodsUpdateCount = 0! !

!KKDBTest methodsFor: 'tests' stamp: 'CDavidShaffer 1/22/2013 14:57'!
testGoodsUpdateNotSentOnRollbackOfUnchanged
	"If we rollback a session, unmodified objects should not be sent #goodsUpdate."
	| counter |
	dbOne
		root: KKGoodsUpdateCounter new;
		commit.
	dbOne := KKDatabase connection: connOne.
	dbTwo installWriteBarrier: KKManualWriteBarrier new.
	counter := dbTwo root.
	self assert: counter goodsUpdateCount = 0.
	dbTwo rollback.
	self assert: counter goodsUpdateCount = 0! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 10/18/2010 20:16'!
testGoodsUpdateSentOnRollback
	"If we refresh a session, all modified objects should be sent #goodsUpdate."
	| counter |
	dbOne root 
		at: 'counter'
		put: (counter := KKGoodsUpdateCounter new).
	dbOne commit.
	self assert: counter goodsUpdateCount = 0.
	counter anIvar: 'some value'.
	dbOne rollback.
	self assert: counter goodsUpdateCount = 1! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 10/18/2010 19:30'!
testGoodsUpdateSentOnRollbackEvenWithWriteBarrier
	"If we refresh a session, all modified objects should be sent #goodsUpdate.  This should happen even if a write barrier is installed."
	| counter |
	dbOne
		root: KKGoodsUpdateCounter new;
		commit.
	dbOne := KKDatabase connection: connOne.
	dbTwo installWriteBarrier: KKManualWriteBarrier new.
	counter := dbTwo root.
	counter anIvar: 'something'.
	self assert: counter goodsUpdateCount = 0.
	dbTwo rollback.
	self assert: counter goodsUpdateCount = 1! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 10/18/2010 15:22'!
testGrowingOrderedCollection
	"Indexed collections may need to grow or shrink when being refreshed"
	
	| oc |
	oc := OrderedCollection with: 1 with: 2.
	dbOne root at: 'oc' put: oc.
	dbOne commit.
	
	self assert: (dbTwo root at: 'oc') first = 1.
	self assert: (dbTwo root at: 'oc') second = 2.

	100 timesRepeat: [oc add: oc size + 1].
	dbOne commit.
	
	dbTwo refresh.
	self assert: ((dbTwo root at: 'oc') at: 100) = 100.
! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 10/26/2010 10:43'!
testIdentitySet
	| set x y y2 |
	set := KKIdentitySet database: dbOne.
	x := 1@1.
	y := 2@2.
	set add: x.
	set add: y.
	self assert: (set includes: x).
	self assert: (set includes: y).
	self deny: (set includes: 1@1).
	set remove: x.
	self assert: (set includes: y).
	self deny: (set includes: x).
	dbOne root at: 'set' put: set.
	dbOne commit.
	dbTwo refresh.
	set := dbTwo root at: 'set'.
	y2  := set anyOne.
	self assert: y2 = y.
	self deny: y2 == y.
	self assert: (set includes: y2).
	self deny: (set includes: y).
	! !

!KKDBTest methodsFor: 'tests' stamp: 'CDavidShaffer 1/17/2013 15:09'!
testNil
	"Make sure GOODS is ok with us putting nil in a reference"
	
	dbOne root at: 'key' put: nil.
	dbOne commit.
	
	dbTwo refresh.
	self assert: (dbTwo root includesKey: 'key').
	self assert: (dbTwo root at: 'key') isNil! !

!KKDBTest methodsFor: 'tests' stamp: 'CDavidShaffer 9/18/2012 11:38'!
testNumbers
	dbOne root at: 'fortytwo' put: 42.
	dbOne root at: 'neg3' put: -3.
	dbOne root at: 'zeropointfivefloat' put: 0.5 asFloat.
	dbOne root at: 'ninepointfivefloat' put: 9.5 asFloat.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'fortytwo') = 42.
	self assert: (dbTwo root at: 'neg3') = -3.
	self assert: (dbTwo root at: 'zeropointfivefloat') = 0.5 asFloat.
	self assert: (dbTwo root at: 'ninepointfivefloat') = 9.5 asFloat! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/15/2008 13:25'!
testPessimisticLocking
	"Pessimistic locking should lock-on-write"

	self preparePessimisticLocking.

	"Locks the root object"
	dbOne root value1: KKObjectForWBTest new.
	self 
		should: [ dbTwo root value1: KKObjectForWBTest new ]
		raise: KKLockFailed! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/17/2008 11:17'!
testPessimisticLockingCommitUnlocks
	"Pessimistic locking should unlock on commit"
	self preparePessimisticLocking.

	dbOne root value1: KKObjectForWBTest new.	"locks"
	dbOne commit.	"unlocks"
	dbTwo root value1: KKObjectForWBTest new.
	dbTwo commit! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/17/2008 11:18'!
testPessimisticLockingNoConflict
	"Pessimistic locking should only lock written objects"
	self preparePessimisticLocking.

	dbOne root value1: KKObjectForWBTest new.	"locks"
	dbOne root value2: KKObjectForWBTest new.	"locks"
	dbOne commit.	"unlocks"

	"The following two statements lock different objects -- no conflict"	
	dbOne root value1 name: 'blah'.
	dbTwo root value2 name: 'foo'.

	dbOne commit.
	dbTwo commit.! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/17/2008 13:14'!
testPessimisticLockingRollback
	"Pessimistic locking should unlock on rollback"

	self preparePessimisticLocking.

	"Locks the root object"
	dbOne root value1: KKObjectForWBTest new.
	dbOne rollback. "unlocks"
	
	self waitAsyncUnlock.
	dbTwo root value1: KKObjectForWBTest new! !

!KKDBTest methodsFor: 'isolation tests' stamp: 'cds 7/15/2008 12:23'!
testReadWriteConflictMode
	"Arrange for a transaction to have modified an object that another one has /read/.  This should be a commit conflict in read-write detection mode."
	dbTwo detectReadWriteConflicts.
	dbOne root 
		at: 'point'
		put: (Array 
				with: 1
				with: 2
				with: 3).
	dbOne root 
		at: 'other'
		put: (Array 
				with: 5
				with: 6
				with: 7).
	dbOne commit.
	dbTwo refresh.
	(dbTwo root at: 'point') printString.	"force it to load"
	(dbTwo root at: 'other') 
		at: 1
		put: 101.
	(dbOne root at: 'point') 
		at: 2
		put: 99.
	dbOne commit.
	self 
		should: [ dbTwo commit ]
		raise: KKCommitFailure! !

!KKDBTest methodsFor: 'isolation tests' stamp: 'cds 5/24/2010 01:30'!
testReadWriteConflicts


	| theObject twosVersion |
	dbTwo detectReadWriteConflicts.
	dbOne detectReadWriteConflicts.

	dbOne root at: 'x' put: Association new.
	dbOne commit.
	
	"Cause dbTwo to load this object"
	twosVersion := dbTwo root at: 'x'.
	twosVersion key.

	"dbOne now modifies this object."
	theObject := dbOne root at: 'x'.
	theObject key: 'foo'.
	dbOne commit.
	
	"dbTwo hasn't modified twosVersion but can't commit because it accessed this Association."
	self should: [dbTwo commit] raise: KKCommitFailure ! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 11/22/2010 11:08'!
testRefreshAfterMultipleChanges
	dbOne root: (Array new: 3).
	dbOne commit.
	
	dbOne root at: 1 put: 'a'->'b'.
	dbOne root at: 2 put: 'c'->'d'.
	dbOne root at: 3 put: 'e'->'f'.
	dbOne commit.
	
	"Force db 2 to load + check sanity"
	self assert: (dbTwo root at: 1) value = 'b'.
	self assert: (dbTwo root at: 2) value = 'd'.
	self assert: (dbTwo root at: 3) value = 'f'.

	(dbOne root at: 1) value: 'q'.
	dbOne commit.
	
	(dbOne root at: 2) value: 'r'.
	dbOne commit.
	
	(dbOne root at: 3) value: 's'.
	dbOne commit.

	dbTwo refresh.	
	self assert: (dbTwo root at: 1) value = 'q'.
	self assert: (dbTwo root at: 2) value = 'r'.
	self assert: (dbTwo root at: 3) value = 's'.
! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 10/24/2010 14:50'!
testRefreshDoesntMakeDirty
	"Make sure that refreshing an object doesn't cause it to be 'dirty'"
	
	dbOne root at: 'x' put: Array new.
	dbTwo root size.  "force dbTwo to fetch dictionary"
	dbOne commit.
	dbTwo refresh.
	dbOne root at: 'y' put: Array new.
	dbOne commit.
	dbTwo commit. "dbTwo has nothing to commit...should not raise an error"
! !

!KKDBTest methodsFor: 'tests' stamp: 'avi 2/25/2004 02:25'!
testRefreshRoot
	dbOne root at: 'x' put: 1.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'x') = 1.
	dbTwo root at: 'y' put: 3.
	dbTwo commit.
	self assert: dbOne root size = 1.
	dbOne refresh.
	self assert: dbOne root size = 2.! !

!KKDBTest methodsFor: 'tests' stamp: 'avi 10/7/2004 17:15'!
testRollbackExistingObject
	dbOne root: #(1 2 3) copy.
	dbOne commit.
	dbTwo root at: 1 put: 0.
	dbTwo commit.
	dbOne refresh.
	dbOne rollback.
	self assert: dbOne root = dbTwo root! !

!KKDBTest methodsFor: 'tests' stamp: 'cds 4/3/2010 14:40'!
testRootNode
	self assert: (dbOne root isKindOf: Dictionary).
	dbOne root: #(23).
	dbOne commit.
	dbTwo refresh.
	self assert: dbTwo root = #(23).! !

!KKDBTest methodsFor: 'isolation tests' stamp: 'cds 7/15/2008 12:21'!
testSerializable
	"Arrange for a transaction to have modified an object that another one has /read/.  This should be a commit conflict in serializable mode."
	dbTwo detectReadWriteConflicts.
	dbOne root 
		at: 'point'
		put: (Array 
				with: 1
				with: 2
				with: 3).
	dbOne root 
		at: 'other'
		put: (Array 
				with: 5
				with: 6
				with: 7).
	dbOne commit.
	dbTwo refresh.
	(dbTwo root at: 'point') printString.	"force it to load"
	(dbTwo root at: 'other') 
		at: 1
		put: 101.
	(dbOne root at: 'point') 
		at: 2
		put: 99.
	dbOne commit.
	self 
		should: [ dbTwo commit ]
		raise: KKCommitFailure! !

!KKDBTest methodsFor: 'tests' stamp: 'avi 7/6/2004 12:17'!
testSpecialObjects
	dbOne root at: 'test' put: dbOne.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'test') == dbTwo! !

!KKDBTest methodsFor: 'tests' stamp: 'rbb 10/31/2003 16:16'!
testTransactions
	" testNode1 should be an OrderedCollection"
	| dbOneNode1 dbTwoNode1 |
	dbOneNode1 := dbOne root at: 'TestNode1' ifAbsentPut: [OrderedCollection new].
	dbOne commit.
	dbTwo refresh.
	dbTwoNode1 := dbTwo root at: 'TestNode1'.
	
	dbOneNode1 reset.
	self assert: dbOneNode1 isEmpty.
	(1 to: 10) do: [:i | dbOneNode1 add: i].
	dbOne commit.
	dbTwo refresh.
	self assert: dbTwoNode1 asArray = #(1 2 3 4 5 6 7 8 9 10).
	
	dbOneNode1 reset.
	(11 to: 20) do: [:i | dbOneNode1 add: i].
	dbOne rollback.
	dbTwo refresh.
	self deny: dbTwoNode1 asArray =  #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20).
	! !

!KKDBTest methodsFor: 'isolation tests' stamp: 'cds 7/15/2008 12:23'!
testWriteWriteConflictMode
	"Arrange for a transaction to have modified an object that another one has /read/.  This should not be a commit conflict in write-write detection mode."
	dbOne root at: 'point' put: (Array with: 1 with: 2 with: 3).
	dbOne root at: 'other' put: (Array with: 5 with: 6 with: 7).
	dbOne commit.
	dbTwo refresh.
	(dbTwo root at: 'point') printString. "force it to load"
	(dbTwo root at: 'other') at: 1 put: 101.
	(dbOne root at: 'point') at: 2 put: 99.
	dbOne commit.
	dbTwo commit! !

!KKDBTest methodsFor: 'locking tests' stamp: 'cds 7/17/2008 13:15'!
waitAsyncUnlock
	"The unlock request is asynchronous (no reply expected) so we wait a little to let it go through"
	(Delay forMilliseconds: 50) wait! !

KKDBTest subclass: #KKThreadSafeDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKThreadSafeDBTest methodsFor: 'running' stamp: 'NicolasPetton 4/20/2011 17:58'!
setUp
	super setUp.
	connOne := self newConnection.
	connTwo := self newConnection.
	dbOne := KKThreadSafeDatabase connection: connOne.
	dbOne root: Dictionary new; commit.
	dbTwo := KKThreadSafeDatabase connection: connTwo.! !

KKAbstractDBTest subclass: #KKShapeChangeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKShapeChangeTest methodsFor: 'running' stamp: 'cds 4/21/2011 17:26'!
expectedExistingVariableName

	^#existingVariable! !

!KKShapeChangeTest methodsFor: 'running' stamp: 'cds 4/21/2011 17:27'!
newConnection
	^ KKConnection 
		hostname: self dbHost
		port: self dbPort! !

!KKShapeChangeTest methodsFor: 'running' stamp: 'cds 4/22/2011 11:54'!
newVariableName

	^#newVariable! !

!KKShapeChangeTest methodsFor: 'running' stamp: 'cds 4/21/2011 17:32'!
tearDown
	"Make sure that KKClassForShapeChangeTest has only one i-var left named #existingVariable"
	
	| names |
	[names := KKClassForShapeChangeTest allInstVarNames.
	names size > 1 ifTrue:
		[names := names copyWithout: self expectedExistingVariableName.
		names do: [:name | KKClassForShapeChangeTest removeInstVarName: name]]] 
			ensure: [super tearDown]! !

!KKShapeChangeTest methodsFor: 'running' stamp: 'cds 4/21/2011 17:32'!
testSanity

	"Make sure that class has expected variable only, add a variable so that tearDown can remove it.  If this test fails then it probably means that KKClassForShapeChangeTest has been modified (maybe by some other test case) and not returned to its correct state."
	
	self assert: (KKClassForShapeChangeTest allInstVarNames size = 1).
	self assert: (KKClassForShapeChangeTest allInstVarNames first = self expectedExistingVariableName).
	
	KKClassForShapeChangeTest addInstVarName: #newVariable.! !

!KKShapeChangeTest methodsFor: 'running' stamp: 'CDavidShaffer 9/18/2012 11:48'!
testTwoDifferentShapesInDatabase

	"Store two instances of KKClassForShapeChangeTest in the database with different shapes.  Make sure that we can make sense out of what we get back."
	
	| instance1 instance2 |
	instance1 := KKClassForShapeChangeTest new.
	instance1 instVarNamed: self expectedExistingVariableName put:  1.
	dbOne root at: 'instance1' put: instance1.
	dbOne commit.
	
	dbTwo refresh.
	KKClassForShapeChangeTest addInstVarName: self newVariableName.
	instance2 := KKClassForShapeChangeTest new.
	instance2 instVarNamed: self expectedExistingVariableName put: 'existing'.
	instance2 instVarNamed: self newVariableName put: 'new'.
	dbTwo root at: 'instance2' put: instance2.
	dbTwo commit.
	
	instance1 := nil.
	instance2 := nil.
	
	dbOne flushAll.
	"self assert: dbOne cacheSize = 0."
	self assert: ((dbOne root at: 'instance1') instVarNamed: self expectedExistingVariableName) = 1.
	self assert: ((dbOne root at: 'instance1') instVarNamed: self newVariableName) isNil.
	self assert: ((dbOne root at: 'instance2') instVarNamed: self expectedExistingVariableName) = 'existing'.
	self assert: ((dbOne root at: 'instance2') instVarNamed: self newVariableName) = 'new'.
	
! !

KKAbstractDBTest subclass: #KKSlowDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKSlowDBTest commentStamp: 'cds 4/27/2011 12:55' prior: 0!
Tests that take a long time so you may not want to run them very often.!

!KKSlowDBTest methodsFor: 'test commit collection' stamp: 'cds 4/27/2011 12:56'!
testStoreLargeCollection
	"Try to put a large collection into GOODS"
	
	| array |
	array := (1 to: 1024*1024) asOrderedCollection.
	dbOne root: Dictionary new.
	dbOne commit.
	dbOne root at: 'oc' put: array.
	dbOne commit.! !

TestCase subclass: #KKManualWriteBarrierTest
	instanceVariableNames: 'barrier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKManualWriteBarrierTest methodsFor: 'running' stamp: 'cds 7/10/2008 13:25'!
setUp
	super setUp.
	barrier := KKManualWriteBarrier new! !

!KKManualWriteBarrierTest methodsFor: 'running' stamp: 'cds 7/10/2008 13:25'!
testAdd
	| obj |
	obj := KKObjectForWBTest new.
	barrier add: obj.
	self assert: (barrier isTracking: obj).
	self assert: barrier dirtySet isEmpty! !

!KKManualWriteBarrierTest methodsFor: 'running' stamp: 'cds 7/10/2008 13:27'!
testChangeDetection
	| obj |
	obj := KKObjectForWBTest new.
	barrier add: obj.
	barrier add: KKObjectForWBTest new.
	barrier add:KKObjectForWBTest new.
	obj name: 'different'.
	self assert: barrier dirtySet size = 1.
	self assert: (barrier dirtySet includes: obj)! !

!KKManualWriteBarrierTest methodsFor: 'running' stamp: 'cds 7/10/2008 13:28'!
testClearDirtySet
	| obj |
	obj := KKObjectForWBTest new.
	barrier add: obj.
	barrier modified: obj.
	barrier clearDirtySet.
	self assert: barrier dirtySet isEmpty! !

!KKManualWriteBarrierTest methodsFor: 'running' stamp: 'cds 7/10/2008 13:29'!
testModified
	| obj |
	obj := KKObjectForWBTest new.
	barrier add: obj.
	barrier modified: obj.
	self assert: barrier dirtySet size = 1.
	self assert: (barrier dirtySet includes: obj)! !

!Character methodsFor: '*goods' stamp: 'avi 7/11/2004 11:58'!
goodsIsImmediateValue
	^ true! !

!UndefinedObject methodsFor: '*goods' stamp: 'avi 2/27/2004 23:18'!
goodsIsImmediateValue
	^ true! !

!Symbol class methodsFor: '*goods' stamp: 'AB 3/8/2002 15:33'!
goodsDescriptorClass 
	^ KKSymbolDescriptor! !

!Metaclass methodsFor: '*goods' stamp: 'cds 12/22/2007 10:55'!
visualworksName
	^self name! !

!Behavior methodsFor: '*goods' stamp: 'avi 10/7/2004 17:13'!
goodsIsImmutable
	^ true! !

!Float methodsFor: '*goods' stamp: 'avi 2/27/2004 23:19'!
goodsIsImmediateValue
	^ true! !

!Float methodsFor: '*goods' stamp: 'AB 3/11/2002 01:29'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 3; uint32: self asIEEE32BitWord ! !

!Duration methodsFor: '*goods' stamp: 'avi 2/26/2004 16:57'!
goodsIsImmutable
	^ true! !

!SmallInteger class methodsFor: '*goods' stamp: 'avi 10/27/2004 16:14'!
goodsDescriptor
	self error: 'Cannot store immediate values as references'	! !

!SmallInteger methodsFor: '*goods' stamp: 'avi 2/27/2004 23:18'!
goodsIsImmediateValue
	^ true! !

!SmallInteger methodsFor: '*goods' stamp: 'AB 3/13/2002 00:36'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 1; nextInt32Put: self.
	! !

Object subclass: #KKAbstractWriteBarrier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-WriteBarrier'!

!KKAbstractWriteBarrier commentStamp: 'cds 6/22/2008 13:18' prior: 0!
I define the API for write barrier implementations.  You can (obivously) subclass or duck-type me.!

!KKAbstractWriteBarrier class methodsFor: 'instance creation' stamp: 'cds 6/20/2008 21:14'!
new
	"Answer a newly created and initialized instance."

	^self basicNew initialize! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'cds 6/20/2008 21:15'!
add: anObject
	"Begin tracking anObject for modifications.  Do not keep a strong reference to anObject!!"! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'cds 6/20/2008 21:15'!
clearDirtySet
	"Mark all objects as clean"! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'CDavidShaffer 1/22/2013 11:46'!
database: aDatabase
	"Tell the write barrier about the database.  All write barriers must notify the database the first time an object is modified (once for each modified object) using the KKDatabase>>objectChanged: message."! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'cds 7/10/2008 11:32'!
dirtySet
	"Answer list of dirty objects"
	self subclassResponsibility! !

!KKAbstractWriteBarrier methodsFor: 'initialize-release' stamp: 'cds 6/20/2008 21:15'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	^self! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'cds 4/4/2010 13:15'!
isAuthoritative
	"Answer true if this write barrier can determine dirty objects authoritatively.  The only class that should answer false here is the 'non-write barrier'"
	
	^true! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'cds 4/4/2010 13:25'!
keyCache: aKeyCache! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'cds 10/24/2010 15:01'!
markClean: anObject
	"remove anObject from our list of dirty objects."
	
! !

!KKAbstractWriteBarrier methodsFor: 'api' stamp: 'cds 6/20/2008 21:15'!
modified: anObject
	"anObject has been 'manually' marked as dirty.  Subsequent calls to dirtSet should include anObject in the response."! !

KKAbstractWriteBarrier subclass: #KKEmptyWriteBarrier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-WriteBarrier'!

!KKEmptyWriteBarrier commentStamp: 'cds 7/10/2008 11:31' prior: 0!
I am a write barrier for use in read-only sessions.  I always indicate that no objects were changed.!

!KKEmptyWriteBarrier methodsFor: 'api' stamp: 'cds 7/10/2008 11:32'!
dirtySet
	^#()! !

KKAbstractWriteBarrier subclass: #KKManualWriteBarrier
	instanceVariableNames: 'dirtyObjects registeredObjects database'
	classVariableNames: 'BarrierRegistry'
	poolDictionaries: ''
	category: 'GOODS-WriteBarrier'!

!KKManualWriteBarrier commentStamp: 'cds 10/24/2010 12:07' prior: 0!
I am a write barrier that requires that objects explicitly notify me when any of their instance variables (or indexed variables) change.  Notification comes by sending the #goodsChanged or #goodsChanged: message in Object.  I am /very limited/ in my usefulness because of this design.  An OrderedCollection, for example, does not send these change notifications so it could not be referenced (stored or retrieved from database) in a session that is using me as a write barrier.  Some collection classes that support the manual write barrier are available in the TrackingCollections class category.!

!KKManualWriteBarrier class methodsFor: 'private-registration' stamp: 'cds 7/10/2008 12:02'!
barrierRegistry
	^BarrierRegistry! !

!KKManualWriteBarrier class methodsFor: 'private-change notification' stamp: 'cds 7/10/2008 12:14'!
barrierTracking: anObject
	^self barrierRegistry detect: [:each |
		each notNil and: [each isTracking: anObject]] ifNone: []! !

!KKManualWriteBarrier class methodsFor: 'private-change notification' stamp: 'cds 10/24/2010 17:48'!
objectChanged: anObject with: anArgument
	| barrier |
	barrier := self barrierTracking: anObject.
	barrier ifNotNil: [barrier modified: anObject]! !

!KKManualWriteBarrier class methodsFor: 'private-registration' stamp: 'cds 7/10/2008 12:02'!
register: anInstance
	self barrierRegistry add: anInstance
! !

!KKManualWriteBarrier methodsFor: 'api' stamp: 'AndyKellens 10/23/2010 10:34'!
add: anObject
	"anObject goodsHasChangeTracking ifFalse: [self error: 'This object does not track changes.']."
	registeredObjects at: anObject put: true! !

!KKManualWriteBarrier methodsFor: 'private' stamp: 'cds 7/14/2008 15:33'!
announceChangeOf: anObject
	database ifNotNil: [database objectChanged: anObject]! !

!KKManualWriteBarrier methodsFor: 'api' stamp: 'AndyKellens 4/17/2010 18:48'!
clearDirtySet
	dirtyObjects := IdentitySet new! !

!KKManualWriteBarrier methodsFor: 'api' stamp: 'cds 7/14/2008 15:26'!
database: aDatabase
	database := aDatabase! !

!KKManualWriteBarrier methodsFor: 'api' stamp: 'cds 7/10/2008 12:17'!
dirtySet
	^dirtyObjects! !

!KKManualWriteBarrier methodsFor: 'initialize-release' stamp: 'cds 4/1/2010 16:22'!
initialize
	super initialize.
	dirtyObjects := IdentitySet new.
	registeredObjects := KKPlatform default weakIdentityKeyDictionary.
	self register.
! !

!KKManualWriteBarrier methodsFor: 'api' stamp: 'cds 7/30/2008 12:57'!
isTracking: anObject
	^registeredObjects includesKey: anObject! !

!KKManualWriteBarrier methodsFor: 'api' stamp: 'cds 10/24/2010 15:01'!
markClean: anObject
	"remove anObject from our list of dirty objects."
	
	(dirtyObjects includes: anObject) ifTrue:
		[dirtyObjects remove: anObject]! !

!KKManualWriteBarrier methodsFor: 'api' stamp: 'AndyKellens 4/17/2010 14:26'!
modified: anObject
	(dirtyObjects includes: anObject) ifFalse:
		[dirtyObjects add: anObject.
		self announceChangeOf: anObject]! !

!KKManualWriteBarrier methodsFor: 'initialize-release' stamp: 'cds 7/30/2008 12:55'!
register
	self class register: self! !

!KKManualWriteBarrier methodsFor: 'initialize-release' stamp: 'cds 7/10/2008 12:20'!
release
	dirtyObjects := nil.
	registeredObjects := nil.
	super release! !

KKAbstractWriteBarrier subclass: #KKNonWriteBarrier
	instanceVariableNames: 'keyCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-WriteBarrier'!

!KKNonWriteBarrier commentStamp: 'cds 4/4/2010 13:04' prior: 0!
I am a "write barrier" for database clients with no write barrier support.  I report everything (except objects which answer true to #goodsIsImmutable) as dirty.!

!KKNonWriteBarrier methodsFor: 'api' stamp: 'cds 4/4/2010 14:04'!
dirtySet

	| result |
	result := Set new.
	keyCache keysAndObjects do: [:value |
		(value goodsIsImmutable not and: [value goodsIsImmediateValue not]) ifTrue: [result add: value]].
	^result! !

!KKNonWriteBarrier methodsFor: 'api' stamp: 'cds 4/4/2010 13:16'!
isAuthoritative 
	"I'm not really a write barrier, so indicate that clients can't count on my answers."

	^false! !

!KKNonWriteBarrier methodsFor: 'api' stamp: 'cds 4/4/2010 13:26'!
keyCache: aKeyCache

	keyCache := aKeyCache! !

Object subclass: #KKCache
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

KKCache subclass: #KKAllocationCache
	instanceVariableNames: 'oids sizes cpids batchSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKAllocationCache commentStamp: 'cds 5/21/2010 22:17' prior: 0!
I keep a cache of pre-allocated object id's.  Before an object can be stored in GOODS, it must be assigned an object id.  Individual object id's can be obtained through the GOODS cmd_alloc command but this is slow.  Instead we pre-allocate batchSize id's.  When we run out of id's we double batchSize (up to max of 256?) and allocate more.

I don't exactly know how GOODS uses the class and size information during this allocation process but when we reload our cache we supply a list of the class (and size estimate) for all objects allocated since the last time we reloaded.

Instance Variables
	batchSize:		Number of oid's to request
	cpids:		Classes-ids of recently allocated objects
	sizes:		Size estimates for recently allocated objects
	oids:		Pre-allocated object ids

!

!KKAllocationCache methodsFor: 'api' stamp: 'CDavidShaffer 1/28/2013 14:19'!
allocateObjectOfClass: aCPID size: aNumber
	oids isEmpty ifTrue: [self reloadCache].
	cpids add: aCPID.
	sizes add: aNumber.
	self log: ['a/allocation: oid = ' , oids first hex].
	^ oids removeFirst! !

!KKAllocationCache methodsFor: 'accessing' stamp: 'CDavidShaffer 1/24/2013 10:31'!
batchSize
	"oids isEmpty ifTrue: [batchSize := batchSize * 2 min: 256]."
	^ batchSize! !

!KKAllocationCache methodsFor: 'api' stamp: 'CDavidShaffer 1/23/2013 23:04'!
hasAllocatedObjects

	^sizes notEmpty! !

!KKAllocationCache methodsFor: 'initialization' stamp: 'CDavidShaffer 1/28/2013 14:21'!
initializeWithDatabase: aDatabase
	super initializeWithDatabase: aDatabase.
	oids := OrderedCollection new.
	cpids := OrderedCollection new.
	sizes := OrderedCollection new.
	batchSize := 100.! !

!KKAllocationCache methodsFor: 'debugging' stamp: 'CDavidShaffer 1/28/2013 14:19'!
log: aString

	KKLogger log: aString! !

!KKAllocationCache methodsFor: 'api' stamp: 'CDavidShaffer 1/23/2013 09:12'!
prepareForCommit
	"The allocation cache might need to do something in preparation for a commit.  In the case of GOODS, we 
	have to repeat our cmd_bulk_alloc request."
	
! !

!KKAllocationCache methodsFor: 'api' stamp: 'CDavidShaffer 1/28/2013 14:19'!
reloadCache
	self log: ['b/reloadCache: sizes=' , sizes printString].
	self log: ['b/reloadCache: oids=' , oids printString].
	oids := (OrderedCollection withAll: (self connection bulkAllocateSizes: sizes classes: cpids reserve: self batchSize - oids size)), oids.
	sizes := OrderedCollection new.
	cpids := OrderedCollection new.
	self log: ['a/reloadCache: oids=' , oids printString].
! !

!KKCache class methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:16'!
database: aDatabase
	^ self basicNew initializeWithDatabase: aDatabase! !

!KKCache methodsFor: 'accessing' stamp: 'cds 7/6/2006 12:16'!
connection
	^database connection! !

!KKCache methodsFor: 'initializing' stamp: 'cds 10/24/2010 12:08'!
initializeWithDatabase: aDatabase
	database := aDatabase.
! !

KKCache subclass: #KKClassCache
	instanceVariableNames: 'cache keys classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKClassCache methodsFor: 'private' stamp: 'AB 3/11/2002 22:58'!
at: aKey
	^ cache at: aKey ifAbsent: [self loadDescriptorAt: aKey]! !

!KKClassCache methodsFor: 'private' stamp: 'AB 3/11/2002 22:40'!
at: aKey put: aClassDescriptor
	cache at: aKey put: aClassDescriptor.
	keys at: aClassDescriptor put: aKey.
	^ aClassDescriptor! !

!KKClassCache methodsFor: 'public' stamp: 'cds 4/21/2011 17:56'!
cacheClassesDuring: aBlock
	classes := Dictionary new.
	^ aBlock ensure: [classes := nil]! !

!KKClassCache methodsFor: 'public' stamp: 'cds 4/21/2011 17:56'!
classForObject: anObject
	^ classes
		ifNil: [self findClassForObject: anObject]
		ifNotNil: [classes at: anObject class ifAbsentPut: [self findClassForObject: anObject]]! !

!KKClassCache methodsFor: 'private' stamp: 'cds 4/21/2011 18:02'!
findClassForObject: anObject 
	| descr storedDescr association |
	descr := anObject class goodsDescriptor.
	
	"Here's where we will detect new classes and schema change.  Our keys dictionary has, as its keys, the class descriptions of classes we've encountered.  If none of the class descriptions in this dictionary match descr, then we've never encountered this type of things before (either its shape changed or we've simply not loaded this class from GOODS)."
	association := keys 
		associationAt: descr
		ifAbsent: [ nil ].
	storedDescr := association ifNotNil: [ association key ].
	^ storedDescr ifNil: [ self storeDescriptor: descr ]! !

!KKClassCache methodsFor: 'initializing' stamp: 'cds 10/24/2010 12:09'!
initializeWithDatabase: aDatabase
	super initializeWithDatabase: aDatabase.
	cache := Dictionary new.
	keys := Dictionary new! !

!KKClassCache methodsFor: 'private' stamp: 'cds 4/21/2011 17:52'!
loadDescriptorAt: aKey
	|descr|
	descr := self connection classAt: aKey.
	descr id: aKey.
	self at: aKey put: descr.
	^ descr! !

!KKClassCache methodsFor: 'private' stamp: 'cds 4/21/2011 17:52'!
storeDescriptor: aClassDescriptor
	| id |
	id := self connection putClass: aClassDescriptor.
	aClassDescriptor id: id.
	self at: id put: aClassDescriptor.
	^ aClassDescriptor! !

KKCache subclass: #KKKeyCache
	instanceVariableNames: 'cache keys recordCache dirtySet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKKeyCache class methodsFor: 'instance creation' stamp: 'cds 6/20/2008 21:21'!
database: aDatabase writeBarrier: aWriteBarrier
	^self basicNew initializeWithDatabase: aDatabase writeBarrier: aWriteBarrier! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 7/14/2008 12:33'!
at: key
	^ self at: key ifAbsent: [self queryOrLoadObjectAt: key]! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 14:58'!
at: key ifAbsent: aBlock
	^ cache at: key ifAbsent: aBlock! !

!KKKeyCache methodsFor: 'private' stamp: 'CDavidShaffer 1/22/2013 14:00'!
at: key put: anObject

	| old |
	old := cache at: key ifAbsent: [].
	old ifNotNil: [keys removeKey: old].

	cache at: key put: anObject.
	keys at: anObject put: key.
	anObject goodsIsImmutable ifFalse: [dirtySet registerObject: anObject]! !

!KKKeyCache methodsFor: 'private' stamp: 'cds 7/6/2006 12:18'!
checkForNewInvalids
	self connection checkForNewInvalids.
! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 4/4/2010 20:07'!
commitAndValidateRead
	| success |
	success := recordCache 
		commitObjects: dirtySet dirtyKeysAndObjects
		andValidate: cache
		hasBarrier: dirtySet hasAuthoritativeWriteBarrier.
	success ifTrue: [ dirtySet reset ].
	^ success! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 4/4/2010 20:07'!
commitNoValidation
	"Commit any dirty records.  Don't try to validate objects read."
	| success |
	success := recordCache 
		commitObjects: dirtySet dirtyKeysAndObjects
		andValidate: nil
		hasBarrier: dirtySet hasAuthoritativeWriteBarrier.
	success ifTrue: [ dirtySet reset ].
	^ success! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 7/15/2008 11:55'!
doCluster
	"Cluster reads (try to read multiple objects at a time speculatively)"
	recordCache doCluster! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 7/15/2008 11:55'!
dontCluster
	"Don't cluster reads (don't try to read multiple objects at a time speculatively)"
	recordCache dontCluster! !

!KKKeyCache methodsFor: 'private' stamp: 'AndyKellens 9/30/2010 19:34'!
emptyWriteBarrier
	dirtySet reset! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 4/22/2011 12:03'!
flushWithFullGC: aBoolean

	| finalized |	
	"No longer refer to loaded objects strongly."
	cache := KKPlatform default integerDictionary.
	aBoolean
		ifTrue: [Smalltalk garbageCollect]
		ifFalse: [Smalltalk garbageCollectMost].
	finalized := IdentitySet new.
	
	"Anyone whose object is nil has been garbage collected, othewise put them back in our cache."
	keys keysAndValuesDo:
		[:object :key |
		object
			ifNil: [finalized add: key]
			ifNotNil: [cache at: key put: object]].
	keys finalizeValues.
	recordCache forgetRecords: finalized.
	database forgetKeys: finalized.
	self connection forgetObjects: finalized asArray.! !

!KKKeyCache methodsFor: 'initializing' stamp: 'cds 10/24/2010 12:10'!
initializeWithDatabase: aDatabase writeBarrier: writeBarrier
	super initializeWithDatabase: aDatabase.
	recordCache := KKRecordCache database: database.
	cache := KKPlatform default integerDictionary.
	keys := KKPlatform default weakIdentityKeyDictionary.
	dirtySet := KKDirtySet keyCache: self writeBarrier: writeBarrier.
	writeBarrier keyCache: self! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 7/17/2008 10:20'!
invalids
	^ self connection invalids! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 15:00'!
keyForObject: anObject
	| key |
	^ keys
		at: anObject
		ifAbsent:
			[key := recordCache allocateObject: anObject.
			self at: key put: anObject.
			key]! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/7/2004 16:50'!
keysAndObjects
	^ cache! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 4/4/2010 12:45'!
keysAndValuesDo: aBlock
	^ cache keysAndValuesDo: aBlock! !

!KKKeyCache methodsFor: 'private' stamp: 'CDavidShaffer 1/22/2013 12:07'!
loadObjectAt: key
	"The record cache /must/ load the latest version of this object, it cannot consult its cached record list."
	| object |
	object := recordCache
		loadObjectAt: key
		ifAbsent: [^nil].
	self refreshObjectAt: key from: object.
	self objectAccessed: (cache at: key).
! !

!KKKeyCache methodsFor: 'private' stamp: 'cds 10/24/2010 14:59'!
markClean: anObject
	"Tell our dirtSet that anObject is not dirty"
	
	dirtySet markClean: anObject! !

!KKKeyCache methodsFor: 'private' stamp: 'cds 7/15/2008 11:12'!
objectAccessed: anObject
	database objectAccessed: anObject! !

!KKKeyCache methodsFor: 'private' stamp: 'CDavidShaffer 1/22/2013 14:33'!
queryOrLoadObjectAt: key
	"It is OK for the record cache to use a previously loaded version of the record at the specified key."
	| object |
	object := recordCache queryOrLoadObjectAt: key ifAbsent: [^nil].
	self refreshObjectAt: key from: object.
	self objectAccessed: (cache at: key).
	^cache at: key! !

!KKKeyCache methodsFor: 'private' stamp: 'cds 4/21/2011 20:42'!
recordCache

	^recordCache! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 4/21/2011 20:45'!
refresh
	| invalids |
	self checkForNewInvalids.
	invalids := self invalids.
	invalids ifNotNil: 
		["We don't need to load records for objects that we haven't accessed (ie exist in the recordCache but not in the keyCache).  We do need to remove them from our recordCache though, so that it doesn't think that it has an up-to-date version of these objects."
		recordCache forgetAll: (invalids asSet difference: cache keys).
		"Load all the ones that we've accessed"
		(invalids select: [:each | cache keys includes: each]) do: [ :key | self loadObjectAt: key ] ]! !

!KKKeyCache methodsFor: 'private' stamp: 'CDavidShaffer 1/22/2013 14:29'!
refreshObjectAt: key from: anObject
	(cache includesKey: key)
		ifFalse: [self at: key put: anObject]
		ifTrue: [(cache at: key) becomeForward: anObject.
				self markClean: (cache at: key).    "#become: may have caused object to be marked dirty"
				(cache at: key) goodsUpdate]! !

!KKKeyCache methodsFor: 'public' stamp: 'cds 10/18/2010 19:23'!
rollback
	dirtySet dirtyKeysAndObjectsDo:
		[:key :object |
		recordCache objectForRecordAt: key ifPresent: 
			[:state |
			object become: state.
			object goodsUpdate.
			database objectRolledBack: object]].
	dirtySet reset! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 16:18'!
root
	^ self at: self rootKey! !

!KKKeyCache methodsFor: 'public' stamp: 'CDavidShaffer 1/24/2013 11:45'!
root: anObject

	| r |
	r := cache at: self rootKey ifAbsent: [self root].
	r
		ifNotNil: [r becomeForward: anObject]
		ifNil: [self at: self rootKey put: anObject].
	dirtySet markDirty: anObject.! !

!KKKeyCache methodsFor: 'private' stamp: 'avi 10/26/2003 16:17'!
rootKey
	^ 16r10000! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 11/5/2003 18:48'!
size
	^ cache size! !

!KKKeyCache methodsFor: 'private' stamp: 'cds 7/10/2008 14:35'!
writeBarrier
	^dirtySet writeBarrier! !

KKCache subclass: #KKRecordCache
	instanceVariableNames: 'cache newObjects classCache allocationCache cluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKRecordCache commentStamp: 'cds 5/22/2010 12:26' prior: 0!
The record cache holds memento (records) of objects that have been read from the database.  These objects may or may not have been accessed by the client since, in many cases, GOODS will send "related" objects speculatively whenever an object is requested.  

I also track new objects (not mementos) that this client will add to the repository during the next commit.  New objects are added via my allocateObject: method.

I am responsible for commiting changes to the database server and for loading records and converting them to objects.!

!KKRecordCache methodsFor: 'private' stamp: 'cds 4/21/2011 16:42'!
addDirtyObjects: aDictionary toRecords: dirtyCollection hasBarrier: hasWriteBarrier
	| newRec oldRec |
	aDictionary copy keysAndValuesDo: 
			[:key :object | 
			object goodsIsImmutable 
				ifFalse: 
					[newRec := self updateRecordForObject: object unlock: 
									database shouldUnlockDirtyOnCommit 
									downgrade: database shouldDowngradeDirtyOnCommit.
					oldRec := cache at: key ifAbsent: [].
					"We only do the record comparison if there is no authoritative write barrier."
					(oldRec isNil or: [hasWriteBarrier or: [(newRec = oldRec) not]]) 
						ifTrue: [dirtyCollection at: key put: newRec]]]! !

!KKRecordCache methodsFor: 'private' stamp: 'CDavidShaffer 1/23/2013 23:04'!
addNewObjectsToRecords: aCollection
	"Add object records for all new objects to aCollection.  This method starts with the list of newObjects but, when creating object records for those object, other new objects may be added to the list.  If I return false, then there were no new objects and you don't need to call me again.  If I answer true, keep calling me."
	| added key |
	added := false.
	"newObjects may be modified during updateRecordForObject:unlock:downgrade:"
	newObjects copy do:
		[:ea |
		key := self keyForObject: ea.
		aCollection at: key ifAbsentPut: [added := true. self updateRecordForObject: ea unlock: false downgrade: false]].
	^ added! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 7/8/2004 11:25'!
addObject: anObject
	newObjects add: anObject! !

!KKRecordCache methodsFor: 'public' stamp: 'avi 2/25/2004 01:42'!
allocateObject: anObject
	| descriptor |
	self addObject: anObject.
	descriptor := classCache classForObject: anObject.
	^ allocationCache allocateObjectOfClass: descriptor id size: descriptor estimatedSize! !

!KKRecordCache methodsFor: 'private' stamp: 'cds 4/21/2011 16:44'!
canCluster
	"Can we ask the database for clusters of objects?  Answering false will mean we receive objects one at a time.  Answering false can impose a significant performance penalty since the backend database may end up sending small objects one at a time across the network, rather than trying to speculate on what object will be requested next."

	^cluster ifNil: [true]! !

!KKRecordCache methodsFor: 'public' stamp: 'CDavidShaffer 1/23/2013 23:04'!
commitObjects: aDictionary andValidate: objectsForValidation hasBarrier: hasWriteBarrier
	"Commit objects in aDictionary and validate (make sure no other session changed) any objects in objectsForValidation.  objectsForValidation should either be nil or a Dictionary of key->object mappings."
	| dirtyRecords cleanRecords validationDict |
	classCache cacheClassesDuring: 
			[dirtyRecords := Dictionary new.
			self 
				addDirtyObjects: aDictionary
				toRecords: dirtyRecords
				hasBarrier: hasWriteBarrier.
			[self addNewObjectsToRecords: dirtyRecords] whileTrue.
			allocationCache hasAllocatedObjects ifTrue: 
				[allocationCache reloadCache].
			cleanRecords :=
				objectsForValidation ifNotNil:
					[validationDict := objectsForValidation copy.
					dirtyRecords keysDo: [:key | validationDict removeKey: key].
					self validationRecordsFor: validationDict].
			(self connection commitRecords: dirtyRecords andValidate: cleanRecords) 
				ifFalse: [^false]
				ifTrue: 
					[newObjects := IdentitySet new.
					self updateCacheFromRecords: dirtyRecords.
					^true]]! !

!KKRecordCache methodsFor: 'private' stamp: 'cds 7/14/2008 12:15'!
createObjectFromRecord: aRecord 
	^ (classCache at: aRecord classKey) 
		objectFromStream: (ReadStream on: aRecord data)
		forDatabase: database! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 7/15/2008 11:55'!
doCluster
	"Cluster reads (try to read multiple objects at a time speculatively)"
	cluster := true! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 7/15/2008 11:55'!
dontCluster
	"Don't cluster reads (don't try to read multiple objects at a time speculatively)"
	cluster := false! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 7/17/2008 11:10'!
forgetAll: keys
	keys do: [:key | cache removeKey: key ifAbsent: []]! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 7/14/2008 12:18'!
forgetRecords: aKeyList
	aKeyList do: [:each | cache removeKey: each]! !

!KKRecordCache methodsFor: 'initializing' stamp: 'cds 10/24/2010 12:10'!
initializeWithDatabase: aDatabase
	super initializeWithDatabase: aDatabase.
	classCache := KKClassCache database: database.
	allocationCache := KKAllocationCache database: database.
	cache := Dictionary new.
	newObjects := IdentitySet new! !

!KKRecordCache methodsFor: 'private' stamp: 'cds 7/6/2006 12:21'!
keyForObject: anObject
	^ database keyForObject: anObject! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 4/1/2010 21:46'!
loadObjectAt: aKey ifAbsent: absentBlock
	"Load the record specified by aKey.  We may get a cluster of objects in return so we'll store all of their records but we only answer the object corresponding to aKey"
	| records |
	records := self refreshAll: (Array with: aKey).
	records isEmpty ifTrue: [ ^ absentBlock value ].
	records first classKey < 2 ifTrue: [^absentBlock value].
	^ self createObjectFromRecord: records first! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 7/14/2008 12:15'!
objectForRecordAt: key ifPresent: aBlock 
	cache 
		at: key
		ifPresent: [ :record | aBlock value: (self createObjectFromRecord: record) ]! !

!KKRecordCache methodsFor: 'public' stamp: 'CDavidShaffer 1/22/2013 14:24'!
queryOrLoadObjectAt: aKey ifAbsent: aBlock 
	"If we have a record in our cache, answer an object created from that record.  Otherwise load the record from GOODS and answer an object corresponding to the loaded object."
	| record result |
	record := cache 
		at: aKey
		ifAbsent: 
			[ ^ self 
				loadObjectAt: aKey
				ifAbsent: aBlock ].
	result := self createObjectFromRecord: record.
	^ result! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 7/15/2008 11:10'!
refreshAll: keyList
	"Refresh our cached versions of all records in keyList"
	| records |
	records := self connection 
		loadObjectsWithKeys: keyList
		copy: false
		cluster: self canCluster.
	self updateCacheFromRecords: records.
	^records! !

!KKRecordCache methodsFor: 'public' stamp: 'cds 4/22/2011 12:07'!
size

	^cache size! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 4/3/2004 15:19'!
updateCacheFromRecords: aCollection
	aCollection do: [:ea | cache at: ea key put: ea]! !

!KKRecordCache methodsFor: 'private' stamp: 'cds 7/17/2008 14:08'!
updateRecordForObject: anObject unlock: unlock downgrade: downgrade
	| descriptor stream|
	descriptor := classCache classForObject: anObject.
	stream := descriptor streamForObject: anObject database: database.

	^ KKObjectRecord
			updateObjectAt: (self keyForObject: anObject)
			classKey: descriptor id
			data: stream contents
			unlock: unlock
			downgrade: downgrade! !

!KKRecordCache methodsFor: 'private' stamp: 'cds 7/17/2008 14:06'!
validateRecordForKey: aKey object: anObject unlock: unlock downgrade: downgrade
	| descriptor |
	descriptor := classCache classForObject: anObject.
	^KKObjectRecord 
		validateObjectAt: aKey
		classKey: descriptor id
		unlock: unlock
		downgrade: downgrade! !

!KKRecordCache methodsFor: 'private' stamp: 'cds 7/17/2008 14:06'!
validationRecordsFor: objectList
	| result |
	result := OrderedCollection new.
	objectList keysAndValuesDo: [:key :object | 
		result add: (self validateRecordForKey: key object: object unlock: database shouldUnlockOnVerify downgrade: database shouldDowngradeOnVerify)].
	^result! !

Object subclass: #KKCachePolicy
	instanceVariableNames: 'keyCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache Policies'!

!KKCachePolicy commentStamp: 'cds 4/28/2011 16:37' prior: 0!
I am an abstract cache policy.  A cache policy determines which objects stay (or should be removed from) the key and record caches and certain cache optimization points.  These optimization points correspond to events like commit, rollback, flush, flushAll but also they occur each time an object is added to either of these caches.!

!KKCachePolicy class methodsFor: 'instance creation' stamp: 'cds 4/28/2011 16:39'!
database: aDatabase

	^self keyCache: aDatabase keyCache! !

!KKCachePolicy class methodsFor: 'instance creation' stamp: 'cds 4/28/2011 16:39'!
keyCache: aKeyCache

	^self basicNew initializeKeyCache: aKeyCache! !

!KKCachePolicy methodsFor: 'initialize-release' stamp: 'cds 4/28/2011 16:38'!
initializeKeyCache: aKeyCache

	keyCache := aKeyCache.
	^self! !

!KKCachePolicy methodsFor: 'accessing' stamp: 'cds 4/28/2011 16:38'!
recordCache

	^keyCache recordCache! !

KKCachePolicy subclass: #KKLRUCachePolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache Policies'!

!KKLRUCachePolicy commentStamp: 'cds 4/28/2011 16:54' prior: 0!
I try to keep the cache size below my high water mark.  I do this by removing clean (not in dirty set) objects that have not been accessed recently.  I do this until the cache object count gets down to my low water mark or there are no objects left that meet my criteria.

Determining when an object was last accessed is tricky....how do I do this?!

KKCachePolicy subclass: #KKUnboundedCachePolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache Policies'!

!KKUnboundedCachePolicy commentStamp: 'cds 4/28/2011 16:51' prior: 0!
I allow the caches to grow without limit.  I must be used in cases where no authoratative write barrier is available (like on Squeak/Pharo unless you're using a KKManualWriteBarrier).!

Object subclass: #KKClassDescriptor
	instanceVariableNames: 'class className fields id classInstVarNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKClassDescriptor class methodsFor: 'as yet unclassified' stamp: 'cds 4/2/2010 10:43'!
findClassForName: aClassName

	^KKClassMapper default findClassForName: aClassName! !

!KKClassDescriptor class methodsFor: 'as yet unclassified' stamp: 'cds 4/21/2011 19:51'!
forClassNamed: aClassName
	"A (GOODS) class has been loaded from the GOODS server.  Create an instance of myself (or subtype) appropriate for that class.  Populate it with the smalltalk class that it corresponds to."

	|class|
	class := self findClassForName: aClassName.
	^ class goodsDescriptorClass new class: class; className: aClassName! !

!KKClassDescriptor methodsFor: 'comparing' stamp: 'AB 3/10/2002 16:42'!
= another
	^ className = another className and: [fields = another fields]! !

!KKClassDescriptor methodsFor: 'actions' stamp: 'AB 3/10/2002 18:07'!
addField: aFieldContainer
	self fields add: aFieldContainer.
	aFieldContainer parent: self.! !

!KKClassDescriptor methodsFor: 'accessing' stamp: 'cds 4/2/2010 10:32'!
class: aClass
	class := aClass.
	classInstVarNames := Dictionary new.
	class allInstVarNames doWithIndex: [:name :index |
		classInstVarNames at: name put: index]! !

!KKClassDescriptor methodsFor: 'accessing' stamp: 'AB 3/10/2002 16:19'!
className
	^ className! !

!KKClassDescriptor methodsFor: 'accessing' stamp: 'AB 3/10/2002 16:19'!
className: aName
	className := aName! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'CDavidShaffer 1/28/2013 08:15'!
estimatedSize
	^ self fixedSize + (self varyingSize * 5)! !

!KKClassDescriptor methodsFor: 'accessing' stamp: 'AB 3/10/2002 17:09'!
fields
	^ fields ifNil: [fields := OrderedCollection new]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:53'!
fixedRefs
	^ (fields select: [:f | f isVariable not and: [f isReference]]) size! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'rbb 8/6/2004 11:58'!
fixedSize
	^ (self fields reject: [:f | f isVariable]) detectSum: [:f | f totalSize]
! !

!KKClassDescriptor methodsFor: 'testing' stamp: 'AB 3/10/2002 16:37'!
hash
	^ className hash + fields hash! !

!KKClassDescriptor methodsFor: 'accessing' stamp: 'AB 3/8/2002 11:57'!
id
	^ id! !

!KKClassDescriptor methodsFor: 'accessing' stamp: 'AB 3/8/2002 11:57'!
id: anID
	id := anID! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'cds 7/7/2006 01:03'!
indexOfInstVarNamed: aName
	^classInstVarNames at: aName ifAbsent: [0]! !

!KKClassDescriptor methodsFor: 'accessing' stamp: 'AB 3/8/2002 15:26'!
instanceClass
	^ class! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 15:26'!
newInstanceFromStream: aStream
	^ self instanceClass basicNew! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:08'!
objectFromStream: aStream forDatabase: aDatabase
	|obj|
	obj := self newInstanceFromStream: aStream.
	self referenceFieldsFirstDo: [:each | each refreshObject: obj fromStream: aStream forDatabase: aDatabase].
	^ obj! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 17:10'!
referenceFieldsFirst
	^ (self fields select: [:f | f isReference]), (self fields reject: [:f | f isReference])! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 20:22'!
referenceFieldsFirstDo: aBlock
	self fields do: [:ea | ea isReference ifTrue: [aBlock value: ea]].
	self fields do: [:ea | ea isReference ifFalse: [aBlock value: ea]]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:26'!
streamForObject: anObject database: aDatabase
	|stream|
	stream := WriteStream on: (ByteArray new: 16).
	self writeObject: anObject onStream: stream forDatabase: aDatabase.
	^ stream! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:48'!
varyingRefs
	^ (fields select: [:f | f isVariable and: [f isReference]]) size! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:51'!
varyingSize
	^ (fields select: [:f | f isVariable]) detectSum: [:f | f totalSize]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:27'!
writeObject: anObject onStream: aStream forDatabase: aDatabase
	self referenceFieldsFirstDo: [:each | each writeObject: anObject onStream: aStream forDatabase: aDatabase]! !

KKClassDescriptor subclass: #KKVariableClassDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

KKVariableClassDescriptor subclass: #KKStringDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

KKStringDescriptor subclass: #KKMetaclassDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStringDescriptor methodsFor: 'accessing' stamp: 'AB 3/8/2002 15:27'!
instanceClass
	^ ByteArray! !

!KKStringDescriptor methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:09'!
objectFromStream: aStream forDatabase: aDatabase
	^ (super objectFromStream: aStream  forDatabase: aDatabase) asString! !

!KKStringDescriptor methodsFor: 'as yet unclassified' stamp: 'cds 6/19/2008 12:37'!
writeObject: anObject onStream: aStream forDatabase: aDatabase
	super writeObject: anObject asByteArray onStream: aStream forDatabase: aDatabase! !

KKStringDescriptor subclass: #KKSymbolDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKSymbolDescriptor methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:09'!
objectFromStream: aStream forDatabase: aDatabase
	^ (super objectFromStream: aStream forDatabase: aDatabase) asSymbol! !

!KKVariableClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 15:30'!
newInstanceFromStream: aStream
	^ self instanceClass basicNew: (aStream contents size - (self fixedSize)) / self varyingSize.! !

Object subclass: #KKClassForShapeChangeTest
	instanceVariableNames: 'existingVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

Object subclass: #KKClassMapper
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'GOODS-Database'!

!KKClassMapper commentStamp: 'cds 4/28/2011 16:16' prior: 0!
I map GOODS persistent class names to and from in-image class names.  I am a singleton.  At the moment I exist to deal with Smalltalk-platform differences in class naming between VisualWorks (with its fully-qualified class names including namespaces) and Squeak.!

!KKClassMapper class methodsFor: 'accessing' stamp: 'cds 4/2/2010 10:42'!
default

	^Default ifNil: [self error: 'The default class mapper was not set.  There should be a classmapper for your platform.  I''ll call it KKMyClassMapper.  You need to make it the default with KKMyClassMapper makeDefault.  This should have been done automatically at startup.']! !

!KKClassMapper class methodsFor: 'accessing' stamp: 'cds 4/2/2010 10:42'!
default: aClassMapper

	Default := aClassMapper! !

!KKClassMapper class methodsFor: 'accessing' stamp: 'cds 4/2/2010 10:43'!
makeDefault

	self default: self new! !

!KKClassMapper methodsFor: 'api' stamp: 'cds 4/28/2011 16:17'!
findClassForName: aClassName
	"Answer the Smalltalk class corresponding to a class named aClassName stored in GOODS"
	
	self subclassResponsibility! !

!KKClassMapper methodsFor: 'api' stamp: 'cds 4/28/2011 16:16'!
nameForClass: aClass
	"Answer the name to use in the GOODS database for Smalltalk class aClass"
	
	self subclassResponsibility! !

Object subclass: #KKClassRecord
	instanceVariableNames: 'fixedSize varyingSize fixedRefs varyingRefs fields name nameSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKClassRecord class methodsFor: 'as yet unclassified' stamp: 'CDavidShaffer 1/25/2013 14:42'!
fromDescriptor: aDescriptor
	^ self new initializeFromDescriptor: aDescriptor! !

!KKClassRecord class methodsFor: 'private' stamp: 'AB 3/7/2002 11:40'!
fromStream: aStream
	^ self new initializeFromStream: aStream! !

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 19:34'!
calculateNameOffsets
	|base i|
	base := fields size * 16.
	i := name size + 1.
	fields do:
		[:each |
		each nameOffset: base + i.
		i := i + each name size + 1].
	nameSize := i.
	! !

!KKClassRecord methodsFor: 'printing' stamp: 'AB 3/9/2002 18:23'!
descriptor
	|descr|
	descr := KKClassDescriptor forClassNamed: name.
	fields do: [:each | descr addField: each descriptor].
	^ descr! !

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 21:32'!
fixIndices
	|indicesSeen|
	indicesSeen := Set new.
	fields do:
		[:each | |index|
		index := each nextIndex.
		((indicesSeen includes: index) or: [index >= fields size])
			ifTrue: [each nextIndex: 0].
		indicesSeen add: index].! !

!KKClassRecord methodsFor: 'initialization' stamp: 'cds 4/2/2010 11:01'!
initializeFromDescriptor: aDescriptor
	fields := aDescriptor fields withIndexCollect:
		[:each :i | (KKFieldRecord fromDescriptor: each atIndex: i - 1)].
	
	fixedSize := aDescriptor fixedSize.
	varyingSize := aDescriptor varyingSize.
	fixedRefs := aDescriptor fixedRefs.
	varyingRefs := aDescriptor varyingRefs.
	name := aDescriptor className.
	
	self fixIndices.
	self calculateNameOffsets.! !

!KKClassRecord methodsFor: 'initialization' stamp: 'AB 3/10/2002 13:44'!
initializeFromStream: aStream
	| fieldCount |
	fixedSize := aStream uint32.
	varyingSize := aStream uint32.
	fixedRefs := aStream uint32.
	varyingRefs := aStream uint32.
	
	fieldCount := aStream uint32.
	nameSize :=  aStream uint32.

	fields := Array new: fieldCount.
	1 to: fieldCount do: [:i |
		fields at: i put: (KKFieldRecord fromStream: aStream atIndex: i - 1)].
	
	name := (aStream upTo: 0) asString.
	fields do: [:field | field name: (aStream upTo: 0) asString].! !

!KKClassRecord methodsFor: 'objects from disk' stamp: 'CDavidShaffer 1/28/2013 14:13'!
writeOn: aStream 
	KKLogger log:
		['writing class ' , name].
	aStream uint32: fixedSize.
	aStream uint32: varyingSize.
	aStream uint32: fixedRefs.
	aStream uint32: varyingRefs.
	aStream uint32: fields size.
	aStream uint32: nameSize.
	fields
		do: [:field | field writeOn: aStream].
	aStream nextPutAll: name asByteArray;
		 nextPut: 0.
	fields
		do: [:field | aStream nextPutAll: field name asByteArray;
				 nextPut: 0]! !

Object subclass: #KKConcurrencyPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Lock Policies'!

!KKConcurrencyPolicy commentStamp: 'cds 7/10/2008 14:09' prior: 0!
A lock policy dictates how and when an object is locked implicitly by the client.  It is provided with opportunities to act on:

	object loaded from database
	object modified for the first time (if a write barrier is in use)
!

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 11:28'!
keysForgotten: aCollection
	"The keys in aCollection are no longer referenced anywhere in the application and have been removed from our client-side caches."
	
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 10:51'!
objectAccessed: anObject
	"Sent the first time anObject is accessed.  Sent once for each object accessed between commits/rollbacks."
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 10:51'!
objectChanged: anObject
	"Sent the first time anObject is changed (if a write barrier is in use).  Sent once for each object changed between commits/rollbacks."
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 13:05'!
objectRolledBack: anObject
	"Sent after the state of anObject has been rolled-back to the version stored
	in the record cache (the version originally loaded by the session)"
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 5/24/2010 00:34'!
requiresWriteBarrier
	"Answer true if and only if this lock policy requires a write barrier."
	
	^self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 11:48'!
setDatabase: aDatabase
	"Sent when the lock policy is installed.  Passed the KKDatabase."
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:13'!
shouldDowngradeDirtyOnCommit
	"Should object locks be downgraded from exclusive to shared when they are being written during commit?"
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:12'!
shouldDowngradeOnVerify
	"Should object locks be downgraded from exclusive to shared when they are being verified during commit?"
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:12'!
shouldUnlockDirtyOnCommit
	"Should objects be unlocked when they are being written during commit?"
	self subclassResponsibility! !

!KKConcurrencyPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:12'!
shouldUnlockOnVerify
	"Should objects be unlocked when they are being verified during commit?"
	self subclassResponsibility! !

KKConcurrencyPolicy subclass: #KKOptimisticLockPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Lock Policies'!

!KKOptimisticLockPolicy commentStamp: 'cds 7/10/2008 14:11' prior: 0!
A lock policy that does not try to implicitly lock any objects.  With this lock policy it is possible that a commit will fail due to a conflict (two sessions modified the same object).!

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 11:28'!
keysForgotten: aCollection! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 10:59'!
objectAccessed: anObject! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/14/2008 15:38'!
objectChanged: anObject
	"With optimistic locking, we don't do anything in reaction to an object change."! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 13:06'!
objectRolledBack: anObject! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 5/24/2010 00:35'!
requiresWriteBarrier

	^false! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 11:48'!
setDatabase: aDatabase
! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:13'!
shouldDowngradeDirtyOnCommit 
	^false! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:14'!
shouldDowngradeOnVerify
	^false! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:13'!
shouldUnlockDirtyOnCommit 
	^false! !

!KKOptimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:14'!
shouldUnlockOnVerify
	^false! !

KKConcurrencyPolicy subclass: #KKPessimisticLockPolicy
	instanceVariableNames: 'database timeoutMilliseconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Lock Policies'!

!KKPessimisticLockPolicy commentStamp: 'cds 7/17/2008 10:35' prior: 0!
Lock an object as soon as it is modified in this session.  Avoids most commit conflicts but can cause deadlocks.  Conflicts can still occur if this session accesses an object written by another session and we are using a Read-Write isolation policy.

To avoid deadlocks you may specify a lock timeout (or zero to simply "try" the lock without waiting).  The longer the timeout, the more "deadlocked"-like your application may appear if there is a lock cycle. A nil timeout indicates an infinite timeout.  Any timeout (besides nil) means that a lock operation, and therefore an object mutation, may fail with a KKLockFailed error.  Applications should be prepared to handle this error by retrying their operation.!

KKPessimisticLockPolicy subclass: #KKConflictFreeLockPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Lock Policies'!

!KKConflictFreeLockPolicy commentStamp: 'cds 7/15/2008 11:50' prior: 0!
The strictist locking policy.  "Shared" lock an object as soon as it is accessed in this session and upgrade that lock to an exclusive lock if/when the object is changed.  Avoids commit conflicts but can cause deadlocks.  See superclass for notes on deadlock avoidance.!

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 11:29'!
keysForgotten: aCollection
	aCollection do: [:key | database unlock: key]! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 12:44'!
objectAccessed: anObject
	self readLock: anObject! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 11:46'!
objectChanged: anObject
	self lock: anObject! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 13:08'!
objectRolledBack: anObject
	self downgradeLock: anObject! !

!KKConflictFreeLockPolicy methodsFor: 'private' stamp: 'cds 7/15/2008 12:41'!
readLock: anObject
	self lock: anObject shared: true! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 4/21/2011 16:48'!
setDatabase: aDatabase

	super setDatabase: aDatabase.
! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:15'!
shouldDowngradeDirtyOnCommit 
	^true! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:15'!
shouldDowngradeOnVerify 
	^false! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:15'!
shouldUnlockDirtyOnCommit 
	^false! !

!KKConflictFreeLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:14'!
shouldUnlockOnVerify 
	^false! !

!KKPessimisticLockPolicy methodsFor: 'private' stamp: 'cds 7/17/2008 13:08'!
downgradeLock: anObject
	database downgradeLock: anObject! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 11:28'!
keysForgotten: aCollection! !

!KKPessimisticLockPolicy methodsFor: 'private' stamp: 'cds 7/15/2008 12:42'!
lock: anObject
	self lock: anObject shared: false! !

!KKPessimisticLockPolicy methodsFor: 'private' stamp: 'cds 7/15/2008 12:42'!
lock: anObject shared: shared
	timeoutMilliseconds ifNotNil:
		[self lockUsingTimeout: anObject shared: shared].
	shared ifTrue: [database readLock: anObject] ifFalse: [database writeLock: anObject]! !

!KKPessimisticLockPolicy methodsFor: 'private' stamp: 'cds 4/3/2010 12:28'!
lockUsingTimeout: anObject shared: shared
	| deadline lockObtained method |
	method := shared ifTrue: [#tryReadLock:] ifFalse: [#tryWriteLock:].
	deadline := Time millisecondClockValue + timeoutMilliseconds.
	[(lockObtained := database perform: method with: anObject) 
		or: [Time millisecondClockValue >= deadline]] whileFalse: 
			["Pick an decent delay"
			|delay|
			delay := (deadline - Time millisecondClockValue) // 10.
			delay > 0 ifTrue: [(Delay forMilliseconds: delay) wait]].
	lockObtained ifFalse: [KKLockFailed raiseSignal: 'Failed to obtain lock']! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 10:59'!
objectAccessed: anObject! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 10:59'!
objectChanged: anObject
	self lock: anObject! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 13:11'!
objectRolledBack: anObject
	self unlock: anObject! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 5/24/2010 00:35'!
requiresWriteBarrier

	^true! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/15/2008 11:48'!
setDatabase: aDatabase
	database := aDatabase! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:14'!
shouldDowngradeDirtyOnCommit 
	^false! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:14'!
shouldDowngradeOnVerify 
	^false! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:14'!
shouldUnlockDirtyOnCommit 
	^true! !

!KKPessimisticLockPolicy methodsFor: 'public' stamp: 'cds 7/17/2008 14:14'!
shouldUnlockOnVerify 
	^false! !

!KKPessimisticLockPolicy methodsFor: 'accessing' stamp: 'cds 7/15/2008 12:32'!
timeoutMilliseconds
	^ timeoutMilliseconds! !

!KKPessimisticLockPolicy methodsFor: 'accessing' stamp: 'cds 7/15/2008 12:32'!
timeoutMilliseconds: anObject
	timeoutMilliseconds := anObject! !

!KKPessimisticLockPolicy methodsFor: 'private' stamp: 'cds 7/17/2008 13:06'!
unlock: anObject
	database unlock: anObject! !

Object subclass: #KKConnection
	instanceVariableNames: 'headerBuf invalids sessionName transport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKConnection class methodsFor: 'private' stamp: 'cds 11/19/2007 10:49'!
calculateCrc: byteArray
	"Translated from GOODS protocol.cxx"
	| crc |
	crc := 0.
	byteArray do: [:byte |
		crc := (self crc32Table at: ((((crc >> 24) bitXor: byte) bitAnd: 255) + 1)) bitXor: (crc << 8).
		crc := crc bitAnd: 16rFFFFFFFF].
	^crc ! !

!KKConnection class methodsFor: 'private' stamp: 'cds 11/19/2007 09:53'!
crc32Table
	^ #(0 79764919 159529838 222504665 319059676 398814059 445009330 507990021 638119352 583659535 797628118 726387553 890018660 835552979 1015980042 944750013 1276238704 1221641927 1167319070 1095957929 1595256236 1540665371 1452775106 1381403509 1780037320 1859660671 1671105958 1733955601 2031960084 2111593891 1889500026 1952343757 2552477408 2632100695 2443283854 2506133561 2334638140 2414271883 2191915858 2254759653 3190512472 3135915759 3081330742 3009969537 2905550212 2850959411 2762807018 2691435357 3560074640 3505614887 3719321342 3648080713 3342211916 3287746299 3467911202 3396681109 4063920168 4143685023 4223187782 4286162673 3779000052 3858754371 3904687514 3967668269 881225847 809987520 1023691545 969234094 662832811 591600412 771767749 717299826 311336399 374308984 453813921 533576470 25881363 88864420 134795389 214552010 2023205639 2086057648 1897238633 1976864222 1804852699 1867694188 1645340341 1724971778 1587496639 1516133128 1461550545 1406951526 1302016099 1230646740 1142491917 1087903418 2896545431 2825181984 2770861561 2716262478 3215044683 3143675388 3055782693 3001194130 2326604591 2389456536 2200899649 2280525302 2578013683 2640855108 2418763421 2498394922 3769900519 3832873040 3912640137 3992402750 4088425275 4151408268 4197601365 4277358050 3334271071 3263032808 3476998961 3422541446 3585640067 3514407732 3694837229 3640369242 1762451694 1842216281 1619975040 1682949687 2047383090 2127137669 1938468188 2001449195 1325665622 1271206113 1183200824 1111960463 1543535498 1489069629 1434599652 1363369299 622672798 568075817 748617968 677256519 907627842 853037301 1067152940 995781531 51762726 131386257 177728840 240578815 269590778 349224269 429104020 491947555 4046411278 4126034873 4172115296 4234965207 3794477266 3874110821 3953728444 4016571915 3609705398 3555108353 3735388376 3664026991 3290680682 3236090077 3449943556 3378572211 3174993278 3120533705 3032266256 2961025959 2923101090 2868635157 2813903052 2742672763 2604032198 2683796849 2461293480 2524268063 2284983834 2364738477 2175806836 2238787779 1569362073 1498123566 1409854455 1355396672 1317987909 1246755826 1192025387 1137557660 2072149281 2135122070 1912620623 1992383480 1753615357 1816598090 1627664531 1707420964 295390185 358241886 404320391 483945776 43990325 106832002 186451547 266083308 932423249 861060070 1041341759 986742920 613929101 542559546 756411363 701822548 3316196985 3244833742 3425377559 3370778784 3601682597 3530312978 3744426955 3689838204 3819031489 3881883254 3928223919 4007849240 4037393693 4100235434 4180117107 4259748804 2310601993 2373574846 2151335527 2231098320 2596047829 2659030626 2470359227 2550115596 2947551409 2876312838 2788305887 2733848168 3165939309 3094707162 3040238851 2985771188 )! !

!KKConnection class methodsFor: 'private' stamp: 'cds 6/23/2008 11:51'!
createTransportHost: hostname port: portNumber
	^self defaultTransportClass hostname: hostname port: portNumber! !

!KKConnection class methodsFor: 'private' stamp: 'cds 4/1/2010 14:36'!
defaultLogin
	^ 'squeak', (Time millisecondClockValue printStringRadix: 16)! !

!KKConnection class methodsFor: 'private' stamp: 'cds 6/23/2008 11:26'!
defaultTransportClass
	^KKDatabase defaultTransportClass! !

!KKConnection class methodsFor: 'instance creation' stamp: 'cds 6/22/2008 16:28'!
hostname: hostname port: portNumber 
	^ self 
		hostname: hostname
		port: portNumber
		sessionName: self defaultLogin! !

!KKConnection class methodsFor: 'instance creation' stamp: 'cds 10/26/2010 08:54'!
hostname: hostname port: portNumber sessionName: aString 
	^ self transport: (self createTransportHost: hostname port: portNumber) sessionName: aString! !

!KKConnection class methodsFor: 'instance creation' stamp: 'cds 10/26/2010 08:54'!
transport: aTransport
	^ self transport: aTransport sessionName: self defaultLogin! !

!KKConnection class methodsFor: 'instance creation' stamp: 'cds 10/26/2010 08:54'!
transport: aTransport sessionName: nameString
	^ (self basicNew initializeWithTransport: aTransport)
		loginWithName: nameString;
		yourself! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:40'!
allocateObjectOfClass: aCPID size: aSize
	self logCommand:
		[self sendCommand: 23
			withShort: aCPID
			withLong: aSize.
		^self receiveLocation]
! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:46'!
bulkAllocateSizes: sizeArray classes: classArray reserve: aNumber 
	| stream buffer |
	self logCommand:
		[stream := WriteStream on: (ByteArray new: 500).
		sizeArray do: [:ea | stream uint32: ea].
		classArray do: [:ea | stream uint16: ea].
		buffer := stream contents.
		self 
			sendCommand: 26
			withLong: sizeArray size
			withLong: aNumber.
		self sendData: buffer.
		^self receiveObjectIDs]! !

!KKConnection methodsFor: 'private' stamp: 'cds 4/3/2010 12:34'!
bye
	transport close.
	Notification raiseSignal: 'GOODS server disconnected'! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:41'!
checkForNewInvalids
	self logCommand:
		[self dataAvailable
			ifTrue: [self receiveIntoHeaderBuffer.
				self headerCommand = 4
					ifTrue: [self receiveInvalids]
					ifFalse: [self error: 'Protocol error, received command ' , self headerCommand printString , ' asynchronously']]]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:41'!
classAt: anID
	self logCommand:
		[self sendCommand: 5 withShort: anID.
		^ self receiveClassDescriptor]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:41'!
commitRecords: dirtyRecords andValidate: cleanRecords 
	| stream buffer |
	self logCommand:
	[(dirtyRecords isEmpty and: [cleanRecords isNil or: [cleanRecords isEmpty]])
		ifTrue: [^true].
	stream := WriteStream on: (ByteArray new: 500).
	dirtyRecords do: [:each | each writeOn: stream].
	cleanRecords ifNotNil: [cleanRecords do: [:each | each writeOn: stream]].
	buffer := stream contents.
	self 
		sendCommand: 13
		withByte: 1
		withShort: 0
		withLong: buffer size
		withLong: 0
		withLong: (self class calculateCrc: buffer).
	self sendData: buffer.
	^self receiveTransactionResult]! !

!KKConnection methodsFor: 'private' stamp: 'cds 6/23/2008 11:54'!
dataAvailable
	^ transport isDataAvailable! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:41'!
forgetObjects: aCollection
	self logCommand: [self forgetOrThrowObjects: aCollection withCommand: 2]! !

!KKConnection methodsFor: 'private' stamp: 'CDavidShaffer 1/22/2013 13:44'!
forgetOrThrowObjects: aCollection withCommand: aCommand
	aCollection isEmpty ifTrue: [^ self].
	
	self sendCommand: aCommand
		withLong: aCollection first
		withLong: aCollection size - 1.
			
	aCollection allButFirst do:
		[:oid |
		self sendCommand: aCommand
			withLong: oid]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:41'!
freeObject: oid
	self logCommand: [self sendCommand: 25 withLong: oid]! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 18:59'!
headerByte
	^ headerBuf at: 2 ! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 18:59'!
headerCommand
	^ headerBuf at: 1! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 19:00'!
headerLong
	^ headerBuf longAt: 5 bigEndian: true! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 19:00'!
headerLong2
	^ headerBuf longAt: 9 bigEndian: true! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 19:00'!
headerShort
	^ headerBuf shortAt: 3 bigEndian: true! !

!KKConnection methodsFor: 'private' stamp: 'cds 6/23/2008 11:44'!
initializeWithTransport: aTransport 
	headerBuf := ByteArray new: 16.
	transport := aTransport! !

!KKConnection methodsFor: 'client commands' stamp: 'cds 11/22/2010 11:09'!
invalids
	[self dataAvailable] whileTrue:
		[self receiveIntoHeaderBuffer.
		self headerCommand = 4 ifFalse: [self error: 'Expecting invalidate'].
		self receiveInvalids].
		
	^ invalids ifNotNil: [|tmp|
		tmp := invalids.
		invalids := nil.
		tmp]
! !

!KKConnection methodsFor: 'client commands' stamp: 'cds 6/23/2008 11:53'!
isConnected
	^ transport isConnected! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:41'!
loadObjectsWithKeys: keyList copy: copyFlag cluster: clusterFlag
	self logCommand:
	[| buffer flag keys |
	keyList isEmpty ifTrue: [^nil].
	keys := keyList asArray.
	buffer := ByteArray new: 16 * keys size.
	flag := (copyFlag ifTrue: [1] ifFalse: [0]) + (clusterFlag ifTrue: [2] ifFalse: [0]).
	self putCommand: 0
		withShort: flag
		withLong: keys first
		withLong: keys size - 1
		into: buffer
		offset: 0.
	2 to: keys size do: [:index|
		self putCommand: 0
			withShort: flag
			withLong: (keys at: index)
			withLong: 0
			into: buffer
			offset: (index - 1) * 16].
	self sendData: buffer.
	^ self receiveObjects]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:42'!
lockObject: anID shared: sharedFlag wait: waitFlag
	self logCommand: 
	[self sendCommand: 10
		withByte: (sharedFlag ifTrue: [1] ifFalse: [2])
		withShort: (waitFlag ifTrue: [0] ifFalse: [1])
		withLong: anID
		withLong: 0.
				
	^ self receiveLockResult]! !

!KKConnection methodsFor: 'debugging' stamp: 'CDavidShaffer 1/28/2013 14:09'!
logCommand: aBlock
	"Wrap the evaluation of aBlock in some debugging information.  Answer self (unless aBlock contains a return)."

	| s |
	s := thisContext sender.
	KKLogger log: '++++++++++++++b/' , s asString.
	aBlock ensure: [KKLogger log: '-------------------a/' , s asString]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:42'!
loginWithName: aName 
	self logCommand:
	[sessionName := aName.
	self sendCommand: 17 withLong: aName size.
	self sendData: aName asByteArray.
	^ self receiveOkOrRefused]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:42'!
logout
	self logCommand:
	[self sendCommand: 18.
	[self receiveHeader] on: Notification do: [^ true]]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:42'!
objectsAt: oid copy: copyFlag cluster: clusterFlag
	self logCommand:
	[self sendCommand: 0
		withShort: (copyFlag ifTrue: [1] ifFalse: [0]) + (clusterFlag ifTrue: [2] ifFalse: [0])
		withLong: oid.
		
	^ self receiveObjects]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:42'!
putClass: aClassDescriptor
	self logCommand:
	[|stream buffer|
	stream := WriteStream on: (ByteArray new: 100).
	(KKClassRecord fromDescriptor: aClassDescriptor) writeOn: stream.
	buffer := stream contents.
	
	self sendCommand: 7 withLong: buffer size.
	self sendData: buffer.
		
	^ self receiveClassID]! !

!KKConnection methodsFor: 'private - sends' stamp: 'cds 7/14/2008 12:00'!
putCommand: aCommand withShort: aShort withLong: aLong withLong: anotherLong into: buffer offset: offset
	buffer at: 1 + offset put: aCommand.
	buffer at: 2 + offset put: 0.
	buffer shortAt: 3 + offset put: aShort bigEndian: true.
	buffer longAt: 5 + offset put: aLong bigEndian: true.
	buffer longAt: 9 + offset put: anotherLong bigEndian: true.
! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/11/2002 02:01'!
receiveClassDescriptor
	|buffer|
	self receiveHeader.
	self headerCommand = 6 ifFalse: [self error: 'Expected class descriptor'].
	buffer := ByteArray new: self headerLong.
	self receiveFullyInto: buffer.
	^ (KKClassRecord fromStream: (ReadStream on: buffer)) descriptor.! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 11:24'!
receiveClassID
	self receiveHeader.
	self headerCommand = 8 ifFalse: [self error: 'Expected class id'].
	^ self headerShort! !

!KKConnection methodsFor: 'private - receives' stamp: 'CDavidShaffer 1/28/2013 14:08'!
receiveFullyInto: aBuffer 
	| current end |
	current := 1.
	end := aBuffer size.
	[current >= end]
		whileFalse: [self isConnected
				ifFalse: [self bye].
			current := current
						+ (transport receiveDataInto: aBuffer startingAt: current)].
	KKLogger logHexBytes: aBuffer labeled: 'received='! !

!KKConnection methodsFor: 'private - receives' stamp: 'cds 4/27/2011 12:53'!
receiveHeader
	"Read the response header into headerBuffer until the response /is not/ an invalidate response (handle invalidate responses by adding them to the invalids list)."

	self receiveIntoHeaderBuffer.
	self headerCommand = 4 ifTrue:
		[self receiveInvalids.
		 self receiveHeader]! !

!KKConnection methodsFor: 'private - receives' stamp: 'CDavidShaffer 1/28/2013 13:46'!
receiveIntoHeaderBuffer
	self receiveFullyInto: headerBuf.
	self headerCommand = 20 ifTrue: [self bye].
! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/10/2002 00:12'!
receiveInvalids
	invalids ifNil: [invalids := Set new].
	invalids add: self headerLong.
	self headerLong2 timesRepeat: [
		self receiveFullyInto: headerBuf.
		invalids add: self headerLong]
! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 01:17'!
receiveLocation
	self receiveHeader.
	self headerCommand = 24 ifFalse: [self error: 'Expecting object location'].
	^ self headerLong! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/10/2002 01:14'!
receiveLockResult
	self receiveHeader.
	self headerCommand = 11 ifFalse: [self error: 'Expecting lock result'].
	^ self headerByte = 1! !

!KKConnection methodsFor: 'private - receives' stamp: 'avi 2/25/2004 01:59'!
receiveObjectIDs
	| buffer readStream |
	self receiveHeader.
	self headerCommand = 27 ifFalse: [self error: 'Expected object ids'].
	buffer := ByteArray new: self headerLong.
	self receiveFullyInto: buffer.
	^ Array streamContents:
		[:s |
		readStream := buffer readStream.
		[readStream atEnd] whileFalse: [s nextPut: readStream uint32]]! !

!KKConnection methodsFor: 'private - receives' stamp: 'cds 7/14/2008 12:37'!
receiveObjects
	|buffer|
	self receiveHeader.
	self headerCommand = 1 ifFalse: [self error: 'Expecting object packet'].
	buffer := ByteArray new: self headerLong.
	self receiveFullyInto: buffer.
	^ self receiveObjectsFromStream: (ReadStream on: buffer).
! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 11:53'!
receiveObjectsFromStream: aStream
	|records|
	records := OrderedCollection new.
	[aStream atEnd] whileFalse:
		[records add: (KKObjectRecord fromStream: aStream)].
	^ records! !

!KKConnection methodsFor: 'private - receives' stamp: 'cds 11/7/2010 10:41'!
receiveOkOrRefused
	| cmd |
	self receiveHeader.
	cmd := self headerCommand.
	(cmd = 21 or: [cmd = 22]) ifFalse: [self error: 'Expected OK or Refuse'].
	^cmd=21! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 14:29'!
receiveTransactionResult
	self receiveHeader.
	self headerCommand = 15 ifFalse: [self error: 'Expecting transaction result'].
	^ self headerByte = 1! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/10/2002 01:19'!
sendCommand: aCommand
	self sendCommand: aCommand
		withByte: 0
		withShort: 0
		withLong: 0
		withLong: 0! !

!KKConnection methodsFor: 'private - sends' stamp: 'CDavidShaffer 1/27/2013 11:26'!
sendCommand: aCommand withByte: aByte withShort: aShort withLong: aLong withLong: anotherLong
	headerBuf at: 1 put: aCommand.
	headerBuf at: 2 put: aByte.
	headerBuf shortAt: 3 put: aShort bigEndian: true.
	headerBuf longAt: 5 put: aLong bigEndian: true.
	headerBuf longAt: 9 put: anotherLong bigEndian: true.
	headerBuf longAt: 13 put: 0 bigEndian: true.
	self sendData: headerBuf.! !

!KKConnection methodsFor: 'private - sends' stamp: 'cds 6/23/2008 10:50'!
sendCommand: aCommand withByte: aByte withShort: aShort withLong: aLong withLong: anotherLong withLong: yetAnotherLong
	headerBuf at: 1 put: aCommand.
	headerBuf at: 2 put: aByte.
	headerBuf shortAt: 3 put: aShort bigEndian: true.
	headerBuf longAt: 5 put: aLong bigEndian: true.
	headerBuf longAt: 9 put: anotherLong bigEndian: true.
	headerBuf longAt: 13 put: yetAnotherLong bigEndian: true.
	self sendData: headerBuf.! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/6/2002 18:34'!
sendCommand: aByte withLong: aLong
	self sendCommand: aByte
			withByte: 0
			withShort: 0
			withLong: aLong
			withLong: 0! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/10/2002 01:05'!
sendCommand: aByte withLong: aLong withLong: anotherLong
	self sendCommand: aByte
			withByte: 0
			withShort: 0
			withLong: aLong
			withLong: anotherLong! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/6/2002 21:18'!
sendCommand: aByte withShort: aShort
	self sendCommand: aByte
			withByte: 0
			withShort: aShort
			withLong: 0
			withLong: 0! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/6/2002 22:37'!
sendCommand: aByte withShort: aShort withLong: aLong
	self sendCommand: aByte
			withByte: 0
			withShort: aShort
			withLong: aLong
			withLong: 0! !

!KKConnection methodsFor: 'private - sends' stamp: 'CDavidShaffer 1/28/2013 14:08'!
sendData: aByteArray
	KKLogger logHexBytes: aByteArray labeled: 'sendData: aByteArray='.
	transport sendData: aByteArray! !

!KKConnection methodsFor: 'private - sends' stamp: 'CDavidShaffer 1/27/2013 11:20'!
sendTruncatedCommand: aCommand withByte: aByte withShort: aShort withLong: aLong withLong: anotherLong
	headerBuf at: 1 put: aCommand.
	headerBuf at: 2 put: aByte.
	headerBuf shortAt: 3 put: aShort bigEndian: true.
	headerBuf longAt: 5 put: aLong bigEndian: true.
	headerBuf longAt: 9 put: anotherLong bigEndian: true.
	self sendData: (headerBuf copyFrom: 1 to: 12).! !

!KKConnection methodsFor: 'private - sends' stamp: 'CDavidShaffer 1/27/2013 11:19'!
sendTruncatedCommand: aByte withLong: aLong withLong: anotherLong
	self sendTruncatedCommand: aByte
			withByte: 0
			withShort: 0
			withLong: aLong
			withLong: anotherLong! !

!KKConnection methodsFor: 'accessing' stamp: 'cds 6/22/2008 16:30'!
sessionName
	^ sessionName! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:42'!
throwObjects: aCollection
	"see goods protocol docs: it isn't clear how this method differs from forgetObjects: but the former is used in the java implementation of a Metaobject protocol while this method is not.  I conjecture that throwObjects is not needed."

	self logCommand: [self forgetOrThrowObjects: aCollection withCommand: 3]! !

!KKConnection methodsFor: 'client commands' stamp: 'CDavidShaffer 1/24/2013 14:42'!
unlockObject: anID completely: aBoolean
	self logCommand:
	[self sendCommand: 12
		withByte: (aBoolean ifTrue: [0] ifFalse: [1])
		withShort: 0
		withLong: anID
		withLong: 0]! !

Object subclass: #KKDatabase
	instanceVariableNames: 'connection keyCache specialObjects isolationLevel lockPolicy'
	classVariableNames: 'DefaultTransportClass WriteBarrierClass'
	poolDictionaries: ''
	category: 'GOODS-Database'!

!KKDatabase class methodsFor: 'instance creation' stamp: 'avi 10/26/2003 15:02'!
connection: aConnection
	^ self basicNew initializeWithConnection: aConnection! !

!KKDatabase class methodsFor: 'private-write barrier' stamp: 'cds 4/1/2010 15:23'!
createWriteBarrierOrNil
	^WriteBarrierClass notNil
		ifTrue: [WriteBarrierClass new] 
		ifFalse: [nil]! !

!KKDatabase class methodsFor: 'global configuration' stamp: 'cds 6/23/2008 11:25'!
defaultTransportClass
	^DefaultTransportClass ifNil: [self error: 'Default transport class must be configured to a platform-appropriate value.  Normally this is done during package loading but for some reason didn''t happen here.  You need to send KKDatabase>>defaultTransportClass: with a concrete subclass of KKTransport.']! !

!KKDatabase class methodsFor: 'global configuration' stamp: 'cds 6/23/2008 11:25'!
defaultTransportClass: aTransportClass
	DefaultTransportClass := aTransportClass! !

!KKDatabase class methodsFor: 'instance creation' stamp: 'avi 10/26/2003 16:27'!
onHost: hostname port: aNumber
	^ self connection: (KKConnection hostname: hostname port: aNumber)! !

!KKDatabase class methodsFor: 'instance creation' stamp: 'cds 6/22/2008 16:28'!
onHost: hostname port: aNumber loginName: aString 
	^ self connection: (KKConnection 
				hostname: hostname
				port: aNumber
				sessionName: aString)! !

!KKDatabase class methodsFor: 'global configuration' stamp: 'cds 5/24/2010 00:26'!
writeBarrierClass

	^WriteBarrierClass! !

!KKDatabase class methodsFor: 'global configuration' stamp: 'AndyKellens 4/17/2010 09:32'!
writeBarrierClass: aClass
	WriteBarrierClass := aClass! !

!KKDatabase methodsFor: 'statistics' stamp: 'cds 4/27/2011 13:21'!
allCachesObjectCount
	"Answer the number of objects in my caches."
	
	^ self keyCacheObjectCount + self recordCacheObjectCount! !

!KKDatabase methodsFor: 'private' stamp: 'cds 4/21/2011 16:46'!
at: oid
	"Answer the object with the specified oid."

	^ keyCache at: oid! !

!KKDatabase methodsFor: 'transactions' stamp: 'cds 4/28/2011 16:17'!
commit
	"Commit any modified persistent objects.   Signals KKCommitFailure if the commit fails.  If the commit succeeds, our view of the database is refreshed."
	
	^ self commitOnFailure: [KKCommitFailure signal]! !

!KKDatabase methodsFor: 'transactions' stamp: 'cds 5/24/2010 00:51'!
commitOnFailure: aBlock
	"Commit.  If the commit fails, evaluate aBlock.  If it succeeds, refresh us (see #refresh)."

	^(self isolationLevel commitKeyCache: keyCache)
		ifTrue: [self refresh]
		ifFalse: aBlock! !

!KKDatabase methodsFor: 'transactions' stamp: 'cds 5/24/2010 00:51'!
commitWithRetry: aBlock
	"Start with a refreshed database (see #refresh).  Evaluate aBlock.  Commit and if the commit fails, rollback and repeat."
	
	| val |
	self refresh.
	val := aBlock value. 
	self commitOnFailure: [self rollback. ^self commitWithRetry: aBlock].
	^ val.! !

!KKDatabase methodsFor: 'private' stamp: 'cds 7/6/2006 12:16'!
connection
	^connection! !

!KKDatabase methodsFor: 'private' stamp: 'cds 4/4/2010 13:22'!
createKeyCacheWithWriteBarrier: aWriteBarrierOrNil 
	^ KKKeyCache 
		database: self
		writeBarrier: (aWriteBarrierOrNil ifNil: [KKNonWriteBarrier new])! !

!KKDatabase methodsFor: 'isolation level' stamp: 'cds 4/28/2011 12:33'!
detectReadWriteConflicts
	"On commit signal KKCommitFailure in the event of write-write and read-write conflicts.
	
	Read write conflicts occur when a session has read an object that was written by an overlapping session.  At commit time, objects that were modified by this session are sent (as usual) but we also request that the GOODS server verify that objects that were simply read by this session were not modified by others.  This is a very strict isolation level and is expected to be useful in only very specialized applications.  Most applications will use #detectWriteWriteConflicts instead."

	isolationLevel := KKReadWriteIsolationLevel new! !

!KKDatabase methodsFor: 'isolation level' stamp: 'cds 4/28/2011 12:34'!
detectWriteWriteConflicts
	"On commit signal KKCommitFailure in the event of write-write conflicts between sessions.
	
	This is the default isolation level.  When a transaction is committed, only objects modified by that transaction are checked against objects modified by other transactions.  If there is an overlap in the modified objects, KKCommitFailure will result."

	isolationLevel := KKWriteWriteIsolationLevel new! !

!KKDatabase methodsFor: 'private' stamp: 'cds 7/15/2008 11:54'!
doCluster
	"Cluster reads (try to read multiple objects at a time speculatively)"
	keyCache doCluster! !

!KKDatabase methodsFor: 'private' stamp: 'cds 7/15/2008 11:54'!
dontCluster
	"Don't cluster reads (don't try to read multiple objects at a time speculatively)"
	keyCache dontCluster! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
downgradeLock: anObject

	connection unlockObject: (self keyForObject: anObject) completely: false! !

!KKDatabase methodsFor: 'transactions' stamp: 'AndyKellens 9/30/2010 19:33'!
emptyWriteBarrier
	keyCache emptyWriteBarrier! !

!KKDatabase methodsFor: 'caching' stamp: 'cds 4/28/2011 12:26'!
flush
	"Remove any objects, that aren't referenced elsewhere, from my caches.  This process involves a garbage collection which, in this method, is just a scavange so not all unreferenced objects will be removed.  See #flushAll.  
	
	If a write barrier is not in use then flush could potentially remove modified objects from the cache and should only be called after a commit or rollback."
	
	keyCache flushWithFullGC: false! !

!KKDatabase methodsFor: 'caching' stamp: 'cds 4/28/2011 12:26'!
flushAll
	"Remove any objects, that aren't referenced elsewhere, from my caches.  This process involves a full garbage collection so all unreferenced objects should be removed at the expense of a potentially significant delay.  See #flush.
	
	If a write barrier is not in use then flushAll could potentially remove modified objects from the cache and should only be called after a commit or rollback."
	
	keyCache flushWithFullGC: true! !

!KKDatabase methodsFor: 'private' stamp: 'cds 5/24/2010 00:37'!
forgetKeys: aCollection
	"These keys have been removed from our keyCache as they are not (strongly) referenced anywhere."
	
	lockPolicy keysForgotten: aCollection! !

!KKDatabase methodsFor: 'initializing' stamp: 'cds 4/1/2010 15:17'!
initializeSpecialObjects
	specialObjects := IdentityDictionary new.
	specialObjects 
		at: self
		put: -1.
	KKPlatform default
		addPlatformSpecialObjectsTo: specialObjects! !

!KKDatabase methodsFor: 'initializing' stamp: 'cds 5/24/2010 00:38'!
initializeWithConnection: aConnection 
	connection := aConnection.
	self initializeSpecialObjects.
	self installWriteBarrier: self class createWriteBarrierOrNil.
	self useOptimisticLocking! !

!KKDatabase methodsFor: 'private' stamp: 'cds 5/24/2010 01:12'!
installLockPolicy: aLockPolicy 
	(aLockPolicy requiresWriteBarrier and: [ keyCache writeBarrier isNil ]) ifTrue: 
		[ self error: 'A write barrier must be in use for a lock policy to be installed.  See #installWriteBarrier or on my class side #writeBarrierClass:' ].
	lockPolicy := aLockPolicy.
	lockPolicy setDatabase: self! !

!KKDatabase methodsFor: 'private' stamp: 'cds 7/14/2008 15:33'!
installWriteBarrier: aWriteBarrierOrNil 
	"Enable a write barrier.  Must be sent before any object is stored or retrieved on this connection!!"
	(keyCache notNil and: [ keyCache keysAndObjects notEmpty ]) ifTrue: 
		[ self error: 'Write barrier must be installed before any objects are loaded or written to the DB' ].
	keyCache := self createKeyCacheWithWriteBarrier: aWriteBarrierOrNil.
	aWriteBarrierOrNil ifNotNil: 
		[aWriteBarrierOrNil database: self.
		self useOptimisticLocking]! !

!KKDatabase methodsFor: 'connection' stamp: 'avi 2/28/2004 14:39'!
isConnected
	^ connection isConnected! !

!KKDatabase methodsFor: 'private' stamp: 'cds 4/28/2011 12:34'!
isolationLevel
	^ isolationLevel ifNil: [self detectWriteWriteConflicts. ^isolationLevel]! !

!KKDatabase methodsFor: 'private' stamp: 'cds 4/28/2011 16:39'!
keyCache

	^keyCache! !

!KKDatabase methodsFor: 'statistics' stamp: 'cds 4/27/2011 13:20'!
keyCacheObjectCount
	"Answer the number of objects in my key cache."
	
	^ keyCache size! !

!KKDatabase methodsFor: 'private' stamp: 'cds 7/4/2006 12:55'!
keyForObject: anObject
	^ anObject class == KKObjectProxy
		ifTrue: [anObject xxxKey]
		ifFalse: [specialObjects at: anObject ifAbsent: [keyCache keyForObject: anObject]]! !

!KKDatabase methodsFor: 'connection' stamp: 'cds 5/24/2010 00:52'!
logout

	connection logout.! !

!KKDatabase methodsFor: 'private-change notification' stamp: 'cds 5/24/2010 00:37'!
objectAccessed: anObject
	"Sent by the key cache when an object is accessed for the first time (once for each object that is accessed)"
	
	lockPolicy objectAccessed: anObject! !

!KKDatabase methodsFor: 'private-change notification' stamp: 'cds 5/24/2010 00:37'!
objectChanged: anObject
	"Sent by the write barrier when an object is changed for the first time (once for each object that is modified)"
	
	lockPolicy objectChanged: anObject! !

!KKDatabase methodsFor: 'private' stamp: 'cds 7/4/2006 12:55'!
objectForKey: key
	^ key > 0
		ifTrue: [keyCache at: key ifAbsent: [KKObjectProxy database: self key: key]]
		ifFalse: [specialObjects keyAtValue: key]! !

!KKDatabase methodsFor: 'private' stamp: 'cds 5/24/2010 00:37'!
objectRolledBack: anObject
	"Sent from the keyCache to tell us that the specified object was rolled back to its original state"
	
	lockPolicy objectRolledBack: anObject! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
readLock: anObject

	connection lockObject: (self keyForObject: anObject) shared: true wait: true! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
readLock: anObject do: aBlock

	self readLock: anObject.
	^ aBlock ensure: [self unlock: anObject]! !

!KKDatabase methodsFor: 'statistics' stamp: 'cds 4/27/2011 13:21'!
recordCacheObjectCount

	^keyCache recordCache size! !

!KKDatabase methodsFor: 'transactions' stamp: 'cds 5/24/2010 00:45'!
refresh
	"Fold changes made by other sessions since our last commit/rollback/start of this session into objects I have loaded.  This may overwrite changes made by this session unless pessimistic locking is being employed."
	
	keyCache refresh! !

!KKDatabase methodsFor: 'transactions' stamp: 'cds 5/24/2010 00:50'!
rollback
	"Return in-image objects that we have modified to the state they were in when we loaded them from the database and then load any changes (to any persistent objects we have in-image) made to the database since the time we last committed/rollbacked/started this session."
	
	keyCache rollback.
	self refresh.! !

!KKDatabase methodsFor: 'accessing' stamp: 'cds 5/24/2010 00:53'!
root

	^ keyCache root! !

!KKDatabase methodsFor: 'accessing' stamp: 'CDavidShaffer 1/22/2013 14:30'!
root: anObject
	"Set the root object of the database to anObject."

	^ keyCache root: anObject! !

!KKDatabase methodsFor: 'accessing' stamp: 'cds 5/24/2010 00:53'!
sessionName

	^ connection sessionName! !

!KKDatabase methodsFor: 'private' stamp: 'cds 5/24/2010 00:38'!
shouldDowngradeDirtyOnCommit 

	^lockPolicy shouldDowngradeDirtyOnCommit! !

!KKDatabase methodsFor: 'private' stamp: 'cds 5/24/2010 00:38'!
shouldDowngradeOnVerify

	^lockPolicy shouldDowngradeOnVerify! !

!KKDatabase methodsFor: 'private' stamp: 'cds 5/24/2010 00:38'!
shouldUnlockDirtyOnCommit 

	^lockPolicy shouldUnlockDirtyOnCommit! !

!KKDatabase methodsFor: 'private' stamp: 'cds 5/24/2010 00:38'!
shouldUnlockOnVerify

	^lockPolicy shouldUnlockOnVerify! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
tryReadLock: anObject

	^ connection lockObject: (self keyForObject: anObject) shared: true wait: false! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
tryWriteLock: anObject

	^ connection lockObject: (self keyForObject: anObject) shared: false wait: false! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
unlock: anObject

	connection unlockObject: (self keyForObject: anObject) completely: true! !

!KKDatabase methodsFor: 'isolation level' stamp: 'cds 4/28/2011 12:39'!
useConflictFreeLocking
	"With conflict-free locking, objects are implicitly shared-locked by the client whenever they are accessed  (you may, of course, lock objects yourself).  When a persistent object is modified, an attempt is made to upgrade this lock to an exclusive lock.  A commit of a transaction should not receive KKCommitFailure in this mode.  Note:
	
	- if a lock timeout is not set, your application may deadlock
	- if a lock timeout is used you may receive KKLockFailed errors on load or mutation of objects
	
	Use of this lock policy requires that a write barrier is in place!!"
	
	self installLockPolicy: KKConflictFreeLockPolicy new.
	^ lockPolicy! !

!KKDatabase methodsFor: 'isolation level' stamp: 'cds 10/24/2010 12:14'!
useOptimisticLocking
	"With optimistic locking, objects are not implicitly locked by the client (you may, of course, lock objects yourself).  A commit of a transaction may fail with a KKCommitFailure if some other session has modified a subset of the objects modified by this session.
	
	Answers the lock policy which has no configuration parameters so ignore it."
	
	self installLockPolicy: KKOptimisticLockPolicy new.
	^ lockPolicy! !

!KKDatabase methodsFor: 'isolation level' stamp: 'cds 10/24/2010 12:15'!
usePessimisticLocking
	"With pessimistic locking, objects are implicitly locked by the client whenever they are changed (you may, of course, lock objects yourself).  A commit of a transaction is less likely to fail with a KKCommitFailure although it may still do so depending on your transaction isolation level.  Note:
	
	- if a lock timeout is not set, your application may deadlock
	- if a lock timeout is used you may receive KKLockFailed errors on mutation of objects
	
	Answers the lock policy which you can configure with a timeout if you like (default is infinite).
	
	Use of this lock policy requires that a write barrier is in place!!"
	
	self installLockPolicy: KKPessimisticLockPolicy new.
	^ lockPolicy! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
writeLock: anObject

	connection lockObject: (self keyForObject: anObject) shared: false wait: true! !

!KKDatabase methodsFor: 'locking' stamp: 'cds 5/24/2010 00:53'!
writeLock: anObject do: aBlock

	self writeLock: anObject.
	^ aBlock ensure: [self unlock: anObject]! !

KKDatabase subclass: #KKThreadSafeDatabase
	instanceVariableNames: 'monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Database'!

!KKThreadSafeDatabase methodsFor: 'accessing' stamp: 'NicolasPetton 4/20/2011 15:00'!
at: aKey
	^self critical: [super at: aKey]! !

!KKThreadSafeDatabase methodsFor: 'transactions' stamp: 'NicolasPetton 4/20/2011 15:01'!
commitOnFailure: aBlock
	^self critical: [super commitOnFailure: aBlock]! !

!KKThreadSafeDatabase methodsFor: 'mutual exclusion' stamp: 'NicolasPetton 4/20/2011 17:56'!
critical: aBlock
	^monitor critical: aBlock! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:03'!
downgradeLock: anObject
	^self critical: [super downgradeLock: anObject]! !

!KKThreadSafeDatabase methodsFor: 'caching' stamp: 'NicolasPetton 4/20/2011 15:06'!
flush
	self critical: [super flush]! !

!KKThreadSafeDatabase methodsFor: 'caching' stamp: 'NicolasPetton 4/20/2011 15:06'!
flushAll
	self critical: [super flushAll]! !

!KKThreadSafeDatabase methodsFor: 'private' stamp: 'NicolasPetton 4/20/2011 16:47'!
forgetKeys: aCollection
	self critical: [super forgetKeys: aCollection]  ! !

!KKThreadSafeDatabase methodsFor: 'initialization' stamp: 'NicolasPetton 4/20/2011 17:55'!
initializeWithConnection: aConnection
	super initializeWithConnection: aConnection.
	monitor := Monitor new! !

!KKThreadSafeDatabase methodsFor: 'testing' stamp: 'NicolasPetton 4/20/2011 16:47'!
isConnected
	^self critical:  [super isConnected]! !

!KKThreadSafeDatabase methodsFor: 'public' stamp: 'NicolasPetton 4/20/2011 17:51'!
logout
	self critical: [super logout]! !

!KKThreadSafeDatabase methodsFor: 'private-change notification' stamp: 'NicolasPetton 4/20/2011 17:56'!
objectAccessed: anObject
	self critical: [super objectAccessed: anObject]! !

!KKThreadSafeDatabase methodsFor: 'private-change notification' stamp: 'NicolasPetton 4/20/2011 17:56'!
objectChanged: anObject
	self critical: [super objectChanged: anObject]! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:18'!
readLock: anObject
	self critical: [super readLock: anObject]! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:13'!
readLock: anObject do: aBlock
	^self critical: [super readLock: anObject do: aBlock]! !

!KKThreadSafeDatabase methodsFor: 'transactions' stamp: 'NicolasPetton 4/20/2011 15:13'!
refresh
	self critical: [super refresh]! !

!KKThreadSafeDatabase methodsFor: 'transactions' stamp: 'NicolasPetton 4/20/2011 15:13'!
rollback
	self critical: [super rollback]! !

!KKThreadSafeDatabase methodsFor: 'accessing' stamp: 'NicolasPetton 4/20/2011 14:58'!
root
	^self critical: [super root]! !

!KKThreadSafeDatabase methodsFor: 'accessing' stamp: 'NicolasPetton 4/20/2011 14:59'!
root: anObject
	^self critical: [super root: anObject]! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:14'!
tryReadLock: anObject
	^self critical: [super tryReadLock: anObject]  ! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:14'!
tryWriteLock: anObject
	^self critical: [super tryWriteLock: anObject]  ! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:14'!
unlock: anObject
	self critical: [super unlock: anObject]! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:17'!
writeLock: anObject
	self critical: [super writeLock: anObject]! !

!KKThreadSafeDatabase methodsFor: 'locking' stamp: 'NicolasPetton 4/20/2011 15:17'!
writeLock: anObject do: aBlock
	^self critical: [super writeLock: anObject do: aBlock]! !

Object subclass: #KKDirtySet
	instanceVariableNames: 'keyCache writeBarrier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKDirtySet class methodsFor: 'as yet unclassified' stamp: 'cds 6/20/2008 21:21'!
keyCache: aKeyCache writeBarrier: aWriteBarrier
	^ self basicNew initializeWithKeyCache: aKeyCache writeBarrier: aWriteBarrier! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 4/4/2010 13:18'!
dirtyKeysAndObjects
	| dict |
	dict := Dictionary new.
	writeBarrier dirtySet do:
		[:ea |
		dict at: (keyCache keyForObject: ea) put: ea].
	^dict! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 4/4/2010 20:05'!
dirtyKeysAndObjectsDo: aBlock

	self dirtyKeysAndObjects keysAndValuesDo: aBlock! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 4/4/2010 20:07'!
hasAuthoritativeWriteBarrier
	^ writeBarrier isAuthoritative! !

!KKDirtySet methodsFor: 'initialization' stamp: 'cds 6/20/2008 21:21'!
initializeWithKeyCache: aKeyCache writeBarrier: aWriteBarrier
	keyCache := aKeyCache.
	writeBarrier := aWriteBarrier! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 10/24/2010 15:00'!
markClean: anObject
	writeBarrier markClean: anObject! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 4/4/2010 13:18'!
markDirty: anObject
	writeBarrier modified: anObject! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 4/4/2010 13:18'!
registerObject: anObject
	writeBarrier add: anObject! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 4/4/2010 13:18'!
reset
	writeBarrier clearDirtySet! !

!KKDirtySet methodsFor: 'public' stamp: 'cds 7/10/2008 14:36'!
writeBarrier
	^writeBarrier! !

Object subclass: #KKDocumentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Documentation'!

!KKDocumentation class methodsFor: 'documentation' stamp: 'cds 4/28/2011 15:34'!
todo

	^'
	* Migrations?  I''d like to have a more client-involved migration strategies.  Right now i-var movement supported but hard to handle i-var renames, class renames (both can be handled via the GOODS console though), i-var type changes etc.
'! !

Object subclass: #KKFieldContainer
	instanceVariableNames: 'fieldType name parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:00'!
booleanField
	^ self new fieldType: KKBooleanField new! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:56'!
byteField
	^ self new fieldType: (KKSignedIntegerField new size: 1)! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:55'!
charField
	^ self new fieldType: (KKUnsignedIntegerField new size: 2)! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:40'!
doubleField
	^ self new fieldType: KKDoubleField new! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:40'!
floatField
	^ self new fieldType: KKFloatField new! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:54'!
intField
	^ self new fieldType: (KKSignedIntegerField new size: 4)! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:55'!
longField
	^ self new fieldType: (KKSignedIntegerField new size: 8)! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:59'!
referenceField
	^ self new fieldType: KKReferenceField new! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:54'!
shortField
	^ self new fieldType: (KKSignedIntegerField new size: 2)! !

!KKFieldContainer methodsFor: 'comparing' stamp: 'AB 3/10/2002 16:49'!
= other
	^ (((name = other name
		and: [self fieldSize = other fieldSize])
		and: [self components = other components])
		and: [self type = other type])! !

!KKFieldContainer methodsFor: 'attributes' stamp: 'avi 11/7/2004 17:17'!
components
	self subclassResponsibility ! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/7/2006 00:54'!
fieldInObject: anObject
	|i|
	i := parent indexOfInstVarNamed: name.
	^ i > 0 ifTrue: [anObject instVarAt: i]! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:49'!
fieldSize
	^ fieldType size! !

!KKFieldContainer methodsFor: 'accessing' stamp: 'AB 3/10/2002 16:43'!
fieldType
	^ fieldType! !

!KKFieldContainer methodsFor: 'accessing' stamp: 'AB 3/8/2002 00:16'!
fieldType: aType
	fieldType := aType! !

!KKFieldContainer methodsFor: 'testing' stamp: 'AB 3/10/2002 16:51'!
hash
	^ name hash + self fieldSize + self components + self type! !

!KKFieldContainer methodsFor: 'testing' stamp: 'AB 3/8/2002 00:16'!
isReference
	^ fieldType isReference! !

!KKFieldContainer methodsFor: 'testing' stamp: 'AB 3/7/2002 23:59'!
isVariable
	^ false! !

!KKFieldContainer methodsFor: 'accessing' stamp: 'AB 3/7/2002 23:36'!
name
	^ name! !

!KKFieldContainer methodsFor: 'accessing' stamp: 'AB 3/7/2002 23:36'!
name: aName
	name := aName! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:54'!
offsetToNextField
	^ 1! !

!KKFieldContainer methodsFor: 'accessing' stamp: 'AB 3/10/2002 18:06'!
parent: aClassDescriptor
	parent := aClassDescriptor! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:09'!
refreshObject: anObject fromStream: aStream forDatabase: aDatabase
	self subclassResponsibility ! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/7/2006 00:55'!
storeField: aField inObject: anObject
	|i|
	i :=  parent indexOfInstVarNamed: name.
	i > 0 ifTrue: [anObject instVarAt: i put: aField]! !

!KKFieldContainer methodsFor: 'accessing' stamp: 'AB 3/7/2002 23:33'!
totalSize
	self subclassResponsibility! !

!KKFieldContainer methodsFor: 'accessing' stamp: 'AB 3/8/2002 00:16'!
type
	^ fieldType type! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:29'!
writeObject: anObject onStream: aStream forDatabase: aDatabase
	self subclassResponsibility ! !

KKFieldContainer subclass: #KKFixedArrayContainer
	instanceVariableNames: 'arraySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKFixedArrayContainer methodsFor: 'accessing' stamp: 'AB 3/8/2002 00:02'!
arraySize: aNumber
	arraySize := aNumber! !

!KKFixedArrayContainer methodsFor: 'accessing' stamp: 'AB 3/8/2002 01:00'!
components
	^ arraySize! !

!KKFixedArrayContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:10'!
refreshObject: anObject fromStream: aStream forDatabase: aDatabase
	|array|
	array := Array new: arraySize.
	1 to: arraySize do:
		[:i | array at: i put:
			(fieldType fieldFromStream: aStream forDatabase: aDatabase)].
	anObject instVarNamed: name put: array.! !

!KKFixedArrayContainer methodsFor: 'accessing' stamp: 'AB 3/8/2002 00:17'!
totalSize
	^ arraySize * fieldType size! !

!KKFixedArrayContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/8/2006 20:24'!
writeObject: anObject onStream: aStream forDatabase: aDatabase
	|array|
	array := anObject instVarNamed: name.
	1 to: (array size min: arraySize) do:
		[:i | fieldType writeField: (array at: i) onStream: aStream forDatabase: aDatabase].
	array size < arraySize
		ifTrue: [aStream next: (arraySize - array size) * fieldType size put: 0]			! !

KKFieldContainer subclass: #KKSingleFieldContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKSingleFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 23:21'!
stringField
	^ self new fieldType: KKStringField new! !

!KKSingleFieldContainer methodsFor: 'attributes' stamp: 'AB 3/7/2002 23:35'!
components
	^ 1! !

!KKSingleFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:10'!
refreshObject: anObject fromStream: aStream forDatabase: aDatabase
	self storeField: (fieldType fieldFromStream: aStream forDatabase: aDatabase) inObject: anObject! !

!KKSingleFieldContainer methodsFor: 'accessing' stamp: 'AB 3/8/2002 00:17'!
totalSize
	^ fieldType size! !

!KKSingleFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/8/2006 20:24'!
writeObject: anObject onStream: aStream forDatabase: aDatabase
	fieldType writeField: (self fieldInObject: anObject) onStream: aStream forDatabase: aDatabase
				! !

KKFieldContainer subclass: #KKStructureContainer
	instanceVariableNames: 'fieldCount size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 21:27'!
calculateSize
	|startIndex|
	startIndex := parent fields identityIndexOf: self.
	^(parent fields copyFrom: startIndex to: startIndex + fieldCount)
		detectSum: [:each | each totalSize]! !

!KKStructureContainer methodsFor: 'attributes' stamp: 'AB 3/10/2002 13:51'!
components
	^ 1! !

!KKStructureContainer methodsFor: 'accessing' stamp: 'AB 3/10/2002 14:02'!
fieldCount: aNumber
	fieldCount := aNumber! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:50'!
fieldSize
	^ size ifNil: [size := self calculateSize]
	 ! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:53'!
fieldSize: aNumber
	size := aNumber! !

!KKStructureContainer methodsFor: 'testing' stamp: 'AB 3/10/2002 13:53'!
isReference
	^ false! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 22:21'!
offsetToNextField
	^ fieldCount + 1! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:10'!
refreshObject: anObject fromStream: aStream forDatabase: aDatabase
! !

!KKStructureContainer methodsFor: 'accessing' stamp: 'AB 3/10/2002 13:58'!
totalSize
	^ 0! !

!KKStructureContainer methodsFor: 'accessing' stamp: 'AB 3/10/2002 13:55'!
type
	^ 0! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/8/2006 20:24'!
writeObject: anObject onStream: aStream forDatabase: aDatabase
! !

KKFieldContainer subclass: #KKVariableFieldContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKVariableFieldContainer methodsFor: 'attributes' stamp: 'AB 3/7/2002 23:38'!
components
	^ 0! !

!KKVariableFieldContainer methodsFor: 'testing' stamp: 'AB 3/7/2002 23:38'!
isVariable
	^ true! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:10'!
refreshObject: anObject fromStream: aStream forDatabase: aDatabase
	anObject class isVariable
		ifTrue: [self refreshVariablePartOfObject: anObject fromStream: aStream forDatabase: aDatabase]
		ifFalse: [self refreshVariableArrayInObject: anObject fromStream: aStream forDatabase: aDatabase].
! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:11'!
refreshVariableArrayInObject: anObject fromStream: aStream forDatabase: aDatabase
	|size array |
	size := ((aStream size - parent fixedSize) / fieldType size).
	array := Array new: size.
	1 to: size do: [:i | array at: i put: (fieldType fieldFromStream: aStream forDatabase: aDatabase)].
	self storeField: array inObject: anObject.! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:11'!
refreshVariablePartOfObject: anObject fromStream: aStream forDatabase: aDatabase
	1 to: anObject basicSize do:
		[:i | anObject basicAt: i put: (fieldType fieldFromStream: aStream forDatabase: aDatabase)]! !

!KKVariableFieldContainer methodsFor: 'accessing' stamp: 'AB 3/8/2002 00:18'!
totalSize
	^ fieldType size! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/8/2006 20:24'!
writeObject: anObject onStream: aStream forDatabase: aDatabase
	anObject class isVariable
		ifTrue: [self writeVariablePartOfObject: anObject onStream: aStream forDatabase: aDatabase]
		ifFalse: [self writeVariableArrayFrom: anObject onStream: aStream forDatabase: aDatabase]
! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:31'!
writeVariableArrayFrom: anObject onStream: aStream forDatabase: aDatabase
	|array|
	array := self fieldInObject: anObject.
	array do: [:each | fieldType writeField: each onStream: aStream forDatabase: aDatabase].! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:31'!
writeVariablePartOfObject: anObject onStream: aStream forDatabase: aDatabase
	1 to: anObject basicSize do:
		[:i | fieldType writeField: (anObject basicAt: i) onStream: aStream forDatabase: aDatabase]
! !

Object subclass: #KKFieldRecord
	instanceVariableNames: 'type size components index nextIndex name nameOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKFieldRecord class methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:27'!
fromDescriptor: aDescriptor atIndex: anIndex
	^ self new initializeFromDescriptor: aDescriptor atIndex: anIndex! !

!KKFieldRecord class methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:30'!
fromStream: aStream atIndex: anIndex
	^ self new initializeFromStream: aStream atIndex: anIndex! !

!KKFieldRecord methodsFor: 'printing' stamp: 'cds 10/28/2010 08:49'!
descriptor
	|fieldType container selectors |
	type = 0 ifTrue:
		[^ KKStructureContainer new
							name: name;
							fieldCount: (nextIndex - index) - 1;
							fieldSize: size].
	selectors := #(makeReferenceField makeSignedIntegerField makeBooleanOrUnsignedIntegerField makeFloatOrDoubleField makeStringField makeStringArrayField).
	
	type <= selectors size ifFalse: [self error: 'unknown field type'].
	fieldType := self perform: (selectors at: type).
	
	container := 
		components = 0
			ifTrue: [KKVariableFieldContainer new]
			ifFalse: [components = 1
						ifTrue: [KKSingleFieldContainer new]
						ifFalse: [KKFixedArrayContainer new arraySize: components]].
	container
		name: name;
		fieldType: fieldType.		
	^ container	! !

!KKFieldRecord methodsFor: 'initialization' stamp: 'AB 3/10/2002 22:19'!
initializeFromDescriptor: aDescriptor atIndex: anIndex
	type := aDescriptor type.
	size := aDescriptor fieldSize.
	components := aDescriptor components.
	name := aDescriptor name.
	index := anIndex.
	nextIndex := anIndex + aDescriptor offsetToNextField ! !

!KKFieldRecord methodsFor: 'initialization' stamp: 'AB 3/10/2002 13:31'!
initializeFromStream: aStream atIndex: anIndex
	type := aStream uint16.
	nameOffset := aStream uint16.
	size := aStream uint32.
	components := aStream uint32. 
	nextIndex := aStream uint32.
	index := anIndex.! !

!KKFieldRecord methodsFor: 'private' stamp: 'cds 10/28/2010 08:47'!
makeBooleanOrUnsignedIntegerField 
	^size = 1
		ifTrue: [KKBooleanField new]
		ifFalse: [KKUnsignedIntegerField new size: size]! !

!KKFieldRecord methodsFor: 'private' stamp: 'cds 10/28/2010 08:47'!
makeFloatOrDoubleField
	^ size = 4
		ifTrue: [KKFloatField new]
		ifFalse: [KKDoubleField new]! !

!KKFieldRecord methodsFor: 'private' stamp: 'cds 10/28/2010 08:46'!
makeReferenceField
	^KKReferenceField new! !

!KKFieldRecord methodsFor: 'private' stamp: 'cds 10/28/2010 08:46'!
makeSignedIntegerField 
	^KKSignedIntegerField new size: size! !

!KKFieldRecord methodsFor: 'private' stamp: 'cds 10/28/2010 08:48'!
makeStringArrayField 
	^KKStringArrayField new! !

!KKFieldRecord methodsFor: 'private' stamp: 'cds 10/28/2010 08:48'!
makeStringField 
	^KKStringField new! !

!KKFieldRecord methodsFor: 'accessing' stamp: 'AB 3/7/2002 12:14'!
name
	^ name! !

!KKFieldRecord methodsFor: 'accessing' stamp: 'AB 3/7/2002 11:47'!
name: aName
	name := aName! !

!KKFieldRecord methodsFor: 'accessing' stamp: 'AB 3/7/2002 12:14'!
nameOffset: aNumber
	nameOffset := aNumber! !

!KKFieldRecord methodsFor: 'accessing' stamp: 'AB 3/10/2002 21:32'!
nextIndex
	^ nextIndex! !

!KKFieldRecord methodsFor: 'accessing' stamp: 'AB 3/7/2002 12:58'!
nextIndex: anIndex
	nextIndex := anIndex! !

!KKFieldRecord methodsFor: 'objects from disk' stamp: 'CDavidShaffer 1/28/2013 14:16'!
writeOn: aStream
	KKLogger log: ['writing field ' , name].
	aStream
		uint16: type;
		uint16: nameOffset;
		uint32: size;
		uint32: components;
		uint32: nextIndex.
! !

Object subclass: #KKFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

KKFieldType subclass: #KKBlobField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKBlobField methodsFor: 'testing' stamp: 'avi 2/26/2004 02:19'!
isReference
	^ false! !

!KKBlobField methodsFor: 'accessing' stamp: 'avi 2/26/2004 02:19'!
size
	^ 4! !

!KKBlobField methodsFor: 'accessing' stamp: 'avi 2/26/2004 02:19'!
type
	^ 6! !

KKFieldType subclass: #KKBooleanField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKBooleanField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:42'!
fieldFromStream: aStream
	^ aStream boolean! !

!KKBooleanField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:00'!
size
	^ 1! !

!KKBooleanField methodsFor: 'accessing' stamp: 'AB 3/11/2002 02:01'!
type
	^ 3! !

!KKBooleanField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:42'!
writeField: aField onStream: aStream
	aStream boolean: aField! !

KKFieldType subclass: #KKDoubleField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKDoubleField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:43'!
fieldFromStream: aStream
	|float|
	float := Float new: 2.
	float at: 1 put: aStream uint32.
	float at: 2 put: aStream uint32.
	^ float
! !

!KKDoubleField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:40'!
size
	^ 8! !

!KKDoubleField methodsFor: 'accessing' stamp: 'cds 5/24/2010 00:17'!
type
	^ 4! !

!KKDoubleField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:43'!
writeField: aField onStream: aStream
	aStream uint32: (aField at: 1).
	aStream uint32: (aField at: 2).
! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'avi 2/26/2004 02:20'!
fieldFromStream: aStream
	self subclassResponsibility ! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:14'!
fieldFromStream: aStream forDatabase: aDatabase
	^self fieldFromStream: aStream! !

!KKFieldType methodsFor: 'testing' stamp: 'AB 3/7/2002 21:51'!
isReference
	^ false! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:26'!
offsetToNextField
	^ 1! !

!KKFieldType methodsFor: 'accessing' stamp: 'avi 11/7/2004 17:17'!
type
	self subclassResponsibility ! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:58'!
writeField: aField onStream: aStream 
	self subclassResponsibility! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:32'!
writeField: aField onStream: aStream forDatabase: aDatabase
	self writeField: aField onStream: aStream! !

KKFieldType subclass: #KKFloatField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKFloatField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:59'!
fieldFromStream: aStream
	^ Float fromIEEE32Bit: aStream uint32! !

!KKFloatField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:40'!
size
	^ 4! !

!KKFloatField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:57'!
type
	^ 4! !

!KKFloatField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:59'!
writeField: aField onStream: aStream
	aStream uint32: aField asIEEE32BitWord ! !

KKFieldType subclass: #KKReferenceField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKReferenceField commentStamp: 'avi 10/27/2003 15:56' prior: 0!
GOODS assumes that static type information is available, and so distinguishes between reference fields and immediate fields. In smalltalk, of course, the same field could hold a string one moment and an integer the next. To accomodate this, I've patched GOODS to support tagged pointers - the high bit of the reference field (actually of the storage id word of the reference field) is used to mark immediate values such as integers, floats, and booleans.

The patch is included in the class comment of KKReferenceField; after filing in the goods changeset, make sure you apply this patch to your GOODS installation.

If you already have GOODS installed, it isn't strictly necessary to apply this patch before trying out the Squeak interface - the goodsrv will work just fine without it until the first GC. At which point it will segfault.

This patch does have the side effect of reducing the maximum possible number of GOODS servers for a single database to around 32000. 32k should be enough for anyone.

For goods-2.71:

--- memmgr.cxx.orig	2002-10-16 10:05:02.000000000 -0700
+++ memmgr.cxx	2003-10-27 14:10:44.000000000 -0800
@@ -1270,11 +1270,13 @@
                 while (--n_refs >= 0) {
                     opid_t ropid;
                     stid_t rsid;
-                    p = unpackref(rsid, ropid, p);
+                p = unpackref(rsid, ropid, p);
+                if(!!(rsid & 0x8000)) {
                     assert(rsid < n_servers
                            && (ropid <= max_opid
                                || (ropid < last_opid && hp[ropid].is_free())));
                 }
+                }
             }
         }
     }
@@ -1705,6 +1707,7 @@
             GC_MARK(opid);
             gc_state |= gcs_cont;
         }
+    } else if (sid & 0x8000) { //tagged pointer
     } else {
         export_buffer* bp = &gc_export_buf[sid];
         opid_t* op = bp->refs;
--- objmgr.cxx.orig	2003-02-26 09:11:40.000000000 -0800
+++ objmgr.cxx	2003-10-27 14:10:44.000000000 -0800
@@ -626,7 +626,7 @@
                             continue;
                         }
                     }
-                    if (old_opid !!= 0) {
+                    if ((old_opid !!= 0) && !!(old_sid & 0x8000)) {
                         rp=rp->next=create_object_reference(old_sid, old_opid);
                     }
                 }
!

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'cds 10/24/2010 17:51'!
decodeUnsignedInteger: anInteger
	^(anInteger bitAnd: 16r80000000) = 0
		ifTrue: [^ anInteger]
		ifFalse: [^ -1 - (anInteger bitXor: 16rFFFFFFFF)]
! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:14'!
fieldFromStream: aStream forDatabase: aDatabase
	|sid oid|
	sid := aStream uint16.
	oid := aStream uint32.

	^ (oid = 0 or: [(sid >> 15) = 1])
			ifTrue: [self fieldFromTag: sid value: oid  forDatabase: aDatabase]
			ifFalse: [self referenceAt: oid database: aDatabase]! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'cds 11/7/2010 10:48'!
fieldFromTag: sid value: oid forDatabase: aDatabase
	^ sid = 0
		ifTrue: [nil]
		ifFalse: [|tag|
			tag := (sid bitAnd: 16r00FF).
			tag = 1 ifTrue: [self decodeUnsignedInteger: oid]
			ifFalse: [tag = 2 ifTrue: [oid = 1]
			ifFalse: [tag = 3 ifTrue: [Float fromIEEE32Bit: oid]
			ifFalse: [tag = 4 ifTrue: [self referenceAt: oid * -1  database: aDatabase]
			ifFalse: [tag = 5 ifTrue: [Character value: oid]
			ifFalse: [self error: 'Invalid object tag']]]]]]
! !

!KKReferenceField methodsFor: 'testing' stamp: 'AB 3/7/2002 21:51'!
isReference
	^ true! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:34'!
keyForReference: anObject database: aDatabase
	^ aDatabase keyForObject: anObject! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 13:13'!
referenceAt: aKey database: aDatabase
	^ aDatabase objectForKey: aKey! !

!KKReferenceField methodsFor: 'accessing' stamp: 'AB 3/7/2002 19:31'!
size
	^ 6! !

!KKReferenceField methodsFor: 'accessing' stamp: 'AB 3/7/2002 19:30'!
type
	^ 1! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:35'!
writeField: anObject onStream: aStream forDatabase: aDatabase
	| oid sid |
	anObject goodsIsImmediateValue
		ifTrue: [self writeTaggedField: anObject onStream: aStream]
		ifFalse:
			[oid := self keyForReference: anObject database: aDatabase.
			oid < 0
				ifTrue: [sid := 16rFF04. oid := oid * -1]
				ifFalse: [sid := 0].
			aStream
				uint16: sid;
				uint32: oid]! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'avi 10/31/2003 14:00'!
writeTaggedField: anObject onStream: aStream
	anObject
		ifNil: [aStream nextNumber: 6 put: 0]
		ifNotNil:
			[aStream nextPut: 255.
			 anObject goodsWriteTaggedOn: aStream].
! !

KKReferenceField subclass: #KKStringArrayField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStringArrayField methodsFor: 'testing' stamp: 'avi 2/26/2004 02:08'!
isReference
	^ false! !

KKFieldType subclass: #KKStringField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStringField methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 14:36'!
fieldFromStream: aStream
	|length string|
	length := aStream uint16.
	string := String new: length.
	
	1 to: length do: [:i | string at: i put: (Character value: aStream uint16)].
	^ string! !

!KKStringField methodsFor: 'testing' stamp: 'AB 3/10/2002 23:17'!
isReference
	^ false! !

!KKStringField methodsFor: 'accessing' stamp: 'AB 3/10/2002 23:17'!
size
	^ 2! !

!KKStringField methodsFor: 'accessing' stamp: 'AB 3/10/2002 23:17'!
type
	^ 5! !

!KKStringField methodsFor: 'as yet unclassified' stamp: 'cds 10/24/2010 17:49'!
writeField: anObject onStream: aStream
	aStream uint16: anObject size.
	anObject do: [:char | aStream uint16: char asInteger].! !

KKFieldType subclass: #KKUnsignedIntegerField
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

KKUnsignedIntegerField subclass: #KKSignedIntegerField
	instanceVariableNames: 'bitMask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 11:26'!
decodeSignedInteger: aNumber
	^ aNumber highBit = (size * 8)
		ifTrue: [((aNumber bitXor: bitMask) + 1) negated]
		ifFalse: [aNumber]! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 11:25'!
encodeSignedInteger: aNumber
	^ aNumber < 0
		ifTrue: [(aNumber bitXor: bitMask) + 1]
		ifFalse: [aNumber]! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:00'!
fieldFromStream: aStream
	^ self decodeSignedInteger: (super fieldFromStream: aStream)! !

!KKSignedIntegerField methodsFor: 'attributes' stamp: 'AB 3/11/2002 11:22'!
size: aNumber
	size := aNumber.
	bitMask := (2 raisedTo: size * 8) - 1.! !

!KKSignedIntegerField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:58'!
type
	^ 2! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'cds 7/6/2006 12:33'!
writeField: aField onStream: aStream forDatabase: aDatabase
	super writeField: (self encodeSignedInteger: aField) onStream: aStream forDatabase: aDatabase! !

!KKUnsignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:01'!
fieldFromStream: aStream
	^ aStream nextNumber: size! !

!KKUnsignedIntegerField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:45'!
size
	^ size! !

!KKUnsignedIntegerField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:45'!
size: aNumber
	size := aNumber! !

!KKUnsignedIntegerField methodsFor: 'accessing' stamp: 'AB 3/11/2002 01:37'!
type
	^ 3! !

!KKUnsignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:01'!
writeField: aField onStream: aStream
	aStream nextNumber: size put: aField! !

Object subclass: #KKGoodsUpdateCounter
	instanceVariableNames: 'anIvar goodsUpdateCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKGoodsUpdateCounter commentStamp: 'cds 10/24/2010 11:54' prior: 0!
I count the number of times #goodsUpdate is sent to me.!

!KKGoodsUpdateCounter methodsFor: 'accessing' stamp: 'cds 4/4/2010 12:00'!
anIvar

	^anIvar! !

!KKGoodsUpdateCounter methodsFor: 'accessing' stamp: 'cds 4/4/2010 12:31'!
anIvar: someValue

	anIvar := someValue.
	self goodsChanged: #someValue! !

!KKGoodsUpdateCounter methodsFor: 'accessing' stamp: 'cds 4/4/2010 12:31'!
goodsHasChangeTracking
	
	^true! !

!KKGoodsUpdateCounter methodsFor: 'copying' stamp: 'cds 10/18/2010 19:21'!
goodsUpdate
	goodsUpdateCount := self goodsUpdateCount + 1! !

!KKGoodsUpdateCounter methodsFor: 'accessing' stamp: 'cds 10/18/2010 19:20'!
goodsUpdateCount
	^ goodsUpdateCount ifNil: [ 0 ]! !

KKGoodsUpdateCounter subclass: #KKImmutableGoodsUpdateCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKImmutableGoodsUpdateCounter commentStamp: 'cds 4/4/2010 14:38' prior: 0!
I am an immutable version of my superclass.!

!KKImmutableGoodsUpdateCounter methodsFor: 'accessing' stamp: 'cds 4/4/2010 14:34'!
anIvar: aValue
	"Ignore"! !

!KKImmutableGoodsUpdateCounter methodsFor: 'accessing' stamp: 'cds 4/4/2010 14:34'!
goodsIsImmutable 

	^true! !

Object subclass: #KKHolderForWBTest
	instanceVariableNames: 'value1 value2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKHolderForWBTest methodsFor: 'accessing' stamp: 'cds 7/15/2008 13:13'!
goodsHasChangeTracking
	^true! !

!KKHolderForWBTest methodsFor: 'accessing' stamp: 'cds 7/15/2008 13:10'!
value1
	^ value1! !

!KKHolderForWBTest methodsFor: 'accessing' stamp: 'cds 7/15/2008 13:10'!
value1: anObject
	value1 := anObject.
	self goodsChanged
	! !

!KKHolderForWBTest methodsFor: 'accessing' stamp: 'cds 7/15/2008 13:10'!
value2
	^ value2! !

!KKHolderForWBTest methodsFor: 'accessing' stamp: 'cds 7/15/2008 13:10'!
value2: anObject
	value2 := anObject.
	self goodsChanged! !

Object subclass: #KKIsolationLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Isolation Level'!

!KKIsolationLevel commentStamp: 'cds 7/10/2008 14:25' prior: 0!
A transaction isolation level.  I permit GOODS clients to ensure different levels of isolation from other transactions.!

!KKIsolationLevel methodsFor: 'public' stamp: 'cds 5/24/2010 01:14'!
commitKeyCache: aKeyCache
	"Sent at commit time.  The isolation level must tell aKeyCache to commit using one of its commit* methods.  Only two choices are to validate /accessed/ objects or not."
	
	self subclassResponsibility! !

KKIsolationLevel subclass: #KKReadWriteIsolationLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Isolation Level'!

!KKReadWriteIsolationLevel commentStamp: 'cds 5/24/2010 01:13' prior: 0!
I am the strictist transaction isolation level supported by GOODS.  In addition to the isolation provided by my superclass, if an object which has been accessed (even for read) in this session has been modified by another session, committing this session will fail with a KKCommitFailure.!

!KKReadWriteIsolationLevel methodsFor: 'public' stamp: 'cds 5/24/2010 01:22'!
commitKeyCache: aKeyCache

	^aKeyCache commitAndValidateRead! !

KKIsolationLevel subclass: #KKWriteWriteIsolationLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Isolation Level'!

!KKWriteWriteIsolationLevel commentStamp: 'cds 7/15/2008 12:20' prior: 0!
I detect write-write conflicts only (objects modified by two concurrent sessions).  If, on commit, a session is detected to have modified an old version of an object (an object which was concurrently modified by another session), fail with KKCommitFailure.!

!KKWriteWriteIsolationLevel methodsFor: 'public' stamp: 'cds 7/14/2008 13:26'!
commitKeyCache: aKeyCache
	^aKeyCache commitNoValidation! !

Object subclass: #KKLogger
	instanceVariableNames: ''
	classVariableNames: 'Enabled'
	poolDictionaries: ''
	category: 'GOODS-Logging'!

!KKLogger class methodsFor: 'as yet unclassified' stamp: 'CDavidShaffer 1/28/2013 14:18'!
disable

	Enabled := false! !

!KKLogger class methodsFor: 'as yet unclassified' stamp: 'CDavidShaffer 1/28/2013 14:18'!
enable

	Enabled := true! !

!KKLogger class methodsFor: 'as yet unclassified' stamp: 'CDavidShaffer 1/28/2013 14:18'!
isLogging

	^Enabled ifNil: [false]! !

!KKLogger class methodsFor: 'as yet unclassified' stamp: 'CDavidShaffer 1/28/2013 14:10'!
log: aStringOrBlock

	self isLogging ifTrue: [Transcript show: aStringOrBlock value; cr]! !

!KKLogger class methodsFor: 'as yet unclassified' stamp: 'CDavidShaffer 1/28/2013 14:06'!
logHexBytes: bytes labeled: label

	| ws |
	ws := WriteStream on: String new.
	ws nextPutAll: label; nextPutAll: ' (' , bytes size printString, ') '.
	bytes do: [:each |
		ws nextPutAll: each hex; space].
	self log: ws contents! !

Object subclass: #KKObjectForWBTest
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKObjectForWBTest methodsFor: 'accessing' stamp: 'cds 7/10/2008 13:21'!
goodsHasChangeTracking
	^true! !

!KKObjectForWBTest methodsFor: 'accessing' stamp: 'cds 7/10/2008 13:20'!
name
	^ name! !

!KKObjectForWBTest methodsFor: 'accessing' stamp: 'cds 7/10/2008 13:20'!
name: anObject
	name := anObject.
	self goodsChanged! !

Object subclass: #KKObjectRecord
	instanceVariableNames: 'txnFlags oid cpid storage data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKObjectRecord class methodsFor: 'private' stamp: 'AB 3/7/2002 11:50'!
fromStream: aStream
	^ self new initializeFromStream: aStream! !

!KKObjectRecord class methodsFor: 'as yet unclassified' stamp: 'cds 7/17/2008 14:17'!
updateObjectAt: aKey classKey: aClassKey data: aByteArray unlock: unlock downgrade: downgrade
	|flags|
	flags := unlock ifTrue: [7] ifFalse: [3].
	downgrade ifTrue: [flags := flags + 8].
	^ self new initializeWithKey: aKey classKey: aClassKey data: aByteArray txnFlags: flags! !

!KKObjectRecord class methodsFor: 'as yet unclassified' stamp: 'cds 7/17/2008 14:17'!
validateObjectAt: aKey classKey: aClassKey unlock: unlock downgrade: downgrade
	|flags|
	flags := unlock ifTrue: [6] ifFalse: [2].
	downgrade ifTrue: [flags := flags + 8].
	^ self new initializeWithKey: aKey classKey: aClassKey data: #() txnFlags: flags! !

!KKObjectRecord methodsFor: 'comparing' stamp: 'cds 10/26/2010 10:15'!
= other
	^ other key = oid
		and: [other classKey = cpid
			and: [other data = data]]! !

!KKObjectRecord methodsFor: 'accessing' stamp: 'AB 3/8/2002 16:06'!
classKey
	^ cpid! !

!KKObjectRecord methodsFor: 'accessing' stamp: 'AB 3/8/2002 16:06'!
data
	^ data! !

!KKObjectRecord methodsFor: 'initialization' stamp: 'AB 3/9/2002 15:31'!
initializeFromStream: aStream
	|size|
	txnFlags := aStream uint32.
	oid := aStream uint32.
	cpid := aStream uint16.
	storage := aStream uint16.
	size := aStream uint32.
	
	data := aStream next: size! !

!KKObjectRecord methodsFor: 'initialization' stamp: 'AB 3/13/2002 12:00'!
initializeWithKey: aKey classKey: aClassKey data: aByteArray txnFlags: aNumber
	oid := aKey.
	cpid := aClassKey.
	data := aByteArray.
	txnFlags := aNumber.
	storage := 0.
! !

!KKObjectRecord methodsFor: 'accessing' stamp: 'AB 3/11/2002 13:29'!
key
	^ oid! !

!KKObjectRecord methodsFor: 'objects from disk' stamp: 'CDavidShaffer 1/28/2013 14:11'!
writeOn: aStream
	KKLogger log: ['writing oid ' , (oid printStringRadix: 16) , ' size ' , data size printString].
	aStream uint32: txnFlags.
	aStream uint32: oid.
	aStream uint16: cpid.
	aStream uint16: storage.
	aStream uint32: data size.
	aStream nextPutAll: data.! !

Object subclass: #KKObjectWithNoIVarsForTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

Object subclass: #KKPlatform
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'GOODS-Database'!

!KKPlatform class methodsFor: 'accessing' stamp: 'cds 4/1/2010 15:15'!
default

	^Default ifNil: [self error: 'The default platform must be set with KKPlatform class>>default:.  This should be given an instance of some concrete subclass of KKPlatform.  Normally this is done during code loading so something is wrong with your GOODS package.']! !

!KKPlatform class methodsFor: 'accessing' stamp: 'cds 4/1/2010 15:15'!
default: aPlatform

	Default := aPlatform! !

!KKPlatform class methodsFor: 'accessing' stamp: 'cds 4/1/2010 15:20'!
makeDefault

	self default: self new! !

!KKPlatform methodsFor: 'special objects' stamp: 'cds 4/1/2010 16:19'!
addPlatformSpecialObjectsTo: specialObjects
	"Add all objects which are unique (singleton) on this platform to specialObjects."
	
	self subclassResponsibility! !

!KKPlatform methodsFor: 'factories' stamp: 'cds 4/1/2010 16:20'!
integerDictionary
	"Answer a dictionary well-suited for integer keys."
	
	self subclassResponsibility! !

!KKPlatform methodsFor: 'factories' stamp: 'cds 4/1/2010 16:21'!
weakIdentityKeyDictionary
	"Answer a dictionary whose keys are stored weakly and compared using object identity."
	
	self subclassResponsibility! !

Object subclass: #KKTestDocumentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKTestDocumentation class methodsFor: 'documentation' stamp: 'cds 4/1/2010 12:03'!
preparingToRunTests
"
The integration tests supplied by KKDBTest require a working GOODS database.  Before you can run those tests you must:

   1) Install GOODS
   2) Create a database configuration file
   3) Start the database server


--------------------------------------------------------------------------
1) Installing the GOODS software

See http://www.garret.ru/goods.html

--------------------------------------------------------------------------
2) Creating a GOODS database configuration file

Begin by creating a directory to house the database:

	FileDirectory default createDirectory: 'db'
	
Add a GOODS configuration file to it.  This configuration file should create a server with a single storage running on port 2006 of localhost:

    ((FileDirectory default directoryNamed: 'db')
		newFileNamed: 'test.cfg')
		 nextPutAll: '1' , String lf;
		 nextPutAll: '0: localhost:2006' , String lf;
		 close.
		
--------------------------------------------------------------------------
3) Starting the database server

I don't recommend starting this server from within your Smalltalk image.  Instead use a shell of some form to enter the command:

cd .......path to db directory.......
goodsrv test

This will leave you in the GOODS database monitor.  Type 'help' for a list of commands.  (Note to shutdown the server you use the 'exit' command.  That is, exiting the monitor, shuts down the server.)

If you insist on starting the server from within your Smalltalk image, squeak users can use OSProcess (install from PackageUniverse) as:

OSProcess command: 'cd db; goodsrv test'
"

	self error: 'Documentation only'
	

	! !

!KKTestDocumentation class methodsFor: 'documentation' stamp: 'cds 4/1/2010 11:47'!
wipingTheTestDatabase
"
If you are getting repeated test failures, you may want to start with an empty test database to ensure that problem isn't a corrupted database root, for example.  To wipe a GOODS database:

1) Stop the server (using the 'exit' command inside goodsrv)
2) remove every file beginning with 'test' except 'test.cfg'

I use the following UNIX script:

#!!/bin/sh
rm -f test.his test.idx test.log test.map test.odb
"

	self error: 'Documentation only'
	

	! !

Object subclass: #KKTransport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKTransport commentStamp: 'cds 6/22/2008 13:21' prior: 0!
I define an socket-like API for concrete implementations.!

!KKTransport class methodsFor: 'instance creation' stamp: 'cds 6/22/2008 16:31'!
hostname: hostname port: portNumber
	^self new initializeHost: hostname port: portNumber! !

!KKTransport class methodsFor: 'default transport' stamp: 'cds 4/1/2010 14:47'!
makeDefault

	KKDatabase defaultTransportClass: self! !

!KKTransport methodsFor: 'api' stamp: 'cds 6/22/2008 14:42'!
close
	"Close this transport"! !

!KKTransport methodsFor: 'initialize-release' stamp: 'cds 6/22/2008 16:32'!
initializeHost: hostname port: portNumber
	"Create and connect to specified host and port number."! !

!KKTransport methodsFor: 'api' stamp: 'cds 6/22/2008 16:38'!
isConnected
	"Answer true if the transport is connected to another endpoint and can send data, false otherwise."! !

!KKTransport methodsFor: 'api' stamp: 'cds 6/22/2008 16:38'!
isDataAvailable
	"Answer true if there is data that can be read from the socket without blocking, false otherwise."! !

!KKTransport methodsFor: 'api' stamp: 'cds 6/23/2008 10:48'!
receiveDataInto: aBuffer startingAt: i
	"Read available data into aBuffer starting at index i either until aBuffer is full or no data remains to be read.  Answer the number of bytes read or zero to indicate that the connection was closed by the other end."! !

!KKTransport methodsFor: 'api' stamp: 'cds 6/22/2008 14:42'!
sendData: aByteArray
	"Send the specified byte array to the server.  This should be an unbuffered Smalltalk-process blocking call."! !

!Object class methodsFor: '*goods' stamp: 'cds 5/24/2010 00:20'!
goodsDescriptor
	|descriptor|
	descriptor := self goodsDescriptorClass new.
	descriptor class: self;
				className: (KKClassMapper default nameForClass: self).
	self goodsFieldDescriptors do: [:field | descriptor addField: field].
	self isVariable ifTrue: [descriptor addField: self goodsVariableFieldDescriptor].
	^ descriptor! !

!Object class methodsFor: '*goods' stamp: 'AB 3/8/2002 15:04'!
goodsDescriptorClass
	^ self isVariable
		ifTrue: [KKVariableClassDescriptor]
		ifFalse: [KKClassDescriptor]! !

!Object class methodsFor: '*goods' stamp: 'AndyKellens 12/13/2010 19:22'!
goodsFieldDescriptorNamed: aName
	|selector|
	selector := (aName, 'Descriptor') asSymbol.
	^ ((self respondsTo: selector)
			ifTrue: [self perform: selector]
			ifFalse: [KKSingleFieldContainer referenceField])
		name: aName! !

!Object class methodsFor: '*goods' stamp: 'cds 5/24/2010 00:19'!
goodsFieldDescriptors
	| fields superFields ivars |
	ivars := self instVarNames reject: [ :each | self goodsTransientFields includes: each ].
	fields := ivars collect: [ :ivar | self goodsFieldDescriptorNamed: ivar ].
	^ (self = Object or: [ superclass = Object ]) 
		ifTrue: [ fields ]
		ifFalse: 
			[ superFields := self superclass goodsFieldDescriptors.
			(Array with: (KKStructureContainer new
					name: (KKClassMapper default nameForClass: self superclass);
					fieldCount: superFields size)) , superFields , fields ]! !

!Object class methodsFor: '*goods' stamp: 'cds 5/24/2010 00:19'!
goodsTransientFields
	"Answer a collection of the names of i-vars to not be stored in GOODS (transient fields)."

	^ #()! !

!Object methodsFor: '*goods-override' stamp: 'avi 11/13/2003 17:26'!
= anObject 
	"Answer whether the receiver and the argument represent the same 
	object. If = is redefined in any subclass, consider also redefining the 
	message hash."

	^self == anObject yourself! !

!Object methodsFor: '*goods' stamp: 'cds 7/10/2008 12:24'!
goodsChanged
	"see goodsChanged:"
	^self goodsChanged: nil! !

!Object methodsFor: '*goods' stamp: 'cds 7/10/2008 12:24'!
goodsChanged: payload
	"This method is part of the manual change tracking mechanism for detecting dirty objects in goods.  Objects which do 'manual' change tracking should send this message to themselves whenever the value of one of their i-vars changes.  You must also override goodsHasChangeTracking to answer true."
	KKManualWriteBarrier objectChanged: self with: payload! !

!Object methodsFor: '*goods' stamp: 'cds 4/3/2010 10:29'!
goodsChangedAfter: aBlock
	"Evaluate aBlock then send goodsChanged to self.  Answer the result of the evaluation of aBlock"
	^aBlock ensure: [self goodsChanged]! !

!Object methodsFor: '*goods' stamp: 'cds 7/10/2008 12:22'!
goodsHasChangeTracking
	"Subclasses that use 'manual' change tracking should override this to answer true.  See goodsChanged:."
	^false! !

!Object methodsFor: '*goods' stamp: 'avi 2/27/2004 23:19'!
goodsIsImmediateValue
	^ false! !

!Object methodsFor: '*goods' stamp: 'cds 7/30/2008 13:37'!
goodsIsImmutable
	^ false! !

!Object methodsFor: '*goods' stamp: 'avi 11/8/2003 00:46'!
goodsUpdate
	! !

!Object methodsFor: '*goods' stamp: 'cds 7/4/2006 12:30'!
xxxIsProxy
	^false! !

!Object methodsFor: '*goods' stamp: 'avi 10/26/2003 21:07'!
yourClass
	^ self class! !
